/************************************************************************/
/*                                                                      */
/*  NAME : HD61700 CROSS ASSEMBLER SOURCE CODE                          */
/*  FILE : hd61700.c                                                    */
/*  Copyright (c)  'BLUE' 2003-2011                                 */
/*                                                                      */
/*  REVISION HISTORY:                                                   */
/*  Rev : 0.01  2003.01.06  ŏ̃o[W                            */
/*                          肠AZu݊œ          */
/*  Rev : 0.02  2003.01.07  pPBAZu\      */
/*                          ső4096s疳ɂ            */
/*  Rev : 0.03  2003.01.09  `Iyhw\Ƃ            */
/*  Rev : 0.04  2003.01.16  `߂ɒǉ                      */
/*                          o͌`pbf/basIłlɂ     */
/*  Rev : 0.05  2003.01.17  xw(CfbNXp)    */
/*  Rev : 0.05a 2003.01.21  G[bZ[WC                        */
/*  Rev : 0.06  2003.01.22  obt@64KBt܂őΉƂ        */
/*  Rev : 0.07  2003.02.03  AI-1000/FX-870P/VX-4AZuɏ        */
/*                          ExZ(D揇ʂȂ)T|[g          */
/*                            p\ȉZq(+-/*&|)                  */
/*                          Exw(.U .D)ABit](.N)T|[g  */
/*                          EIyhɕw\Ƃ        */
/*                          E}`oCgnjjbNXXWXXMɕύX  */
/*                          EIyR[h0x0`0xf0x80`0x8fɑ΂āA   */
/*                            JumpgCl[uƂB              */
/*                          ELJumpg̃xwJR LABEL`  */
/*                            p\ƂB(ʏLABEL̂݋Lq)   */
/*                          EDW^߂Cl[uƂB            */
/*                          ELύXɔ/u p~AZJhIy   */
/*                            [VwfBtHgƂB      */
/*                            (/nIvVPB-1000݊)           */
/*                          ELEVEL^߃T|[g                     */
/*  Rev : 0.08  2003.02.09  xŽ                      */
/*                          ZqD揇ʂ⊇ʂ̎gp\Ƃ      */
/*                          PBIyhOB*/
/*                          ߌT|[gǉ(ŏI\)          */
/*                          ׂoOC                              */
/*  Rev : 0.09  2003.02.16  #if`#else`#endif}ÑT|[gB        */
/*                          ̕]p[!]ZqǉB               */
/*                          t@C8ȏ̎[jO\B */
/*                          x擪̏ꍇG[Ƃ悤 */
/*                          CB                                      */
/*  Rev : 0.10  2003.02.21  #INCLUDE,#LIST,#NOLIST,#EJECTT|[g       */
/*                          ECN[ht@C悤ɏC    */
/*                            (lXg256x܂)                   */
/*                          EXgo͂̋/֎~/y[WT|[g  */
/*                          EQU錾ɂĕ悤ɂB       */
/*                          ߃R[h(0xDA,0xDB)ɑ΂Jumpg */
/*                          ƂB(DIDM,DIUM,BYDM,BYUM,INVM,CMPM)     */
/*                          2i(&B)wǉB                       */
/*                          G[`FbNC                      */
/*  Rev : 0.11  2003.02.22  EQU,LDW̕w̃GfBAt   */
/*                          B                                      */
/*  Rev : 0.12  2003.02.28  xe[u𓮓IɊmۂ悤ɉǁB  */
/*                          őo^OB                    */
/*                          o̓bZ[WCB                        */
/*                          Win32/DOSł̃\[X𓝍B                 */
/*  Rev : 0.12a 2003.03.04  pbft@Co͂CB(DOSł̂ݔ)      */
/*  Rev : 0.13  2003.03.04  ߌǉB                                */
/*  Rev : 0.14  2003.03.05  \ꐧɘaB                          */
/*                          WX^xƂėpƂB  */
/*  Rev : 0.15  2003.03.07  ŏIAhXo͕C                    */
/*                          ̈gAZ\ƂB    */
/*                          KC`̃jjbNɑΉB                  */
/*  Rev : 0.16  2003.03.14  ʌỏsCB                */
/*                          ֌W(r)ZqɑΉB                    */
/*                          Zqʂ_ɂB                    */
/*  Rev : 0.17  2003.03.17  BYD/BYUǉB                               */
/*  Rev : 0.18  2003.03.25  QpXڂŒlm肵ȂxĂ    */
/*                          G[ƂȂȂꍇ̂CB      */
/*  Rev : 0.19  2003.04.06  JR }IM7`̃T|[gB                    */
/*  Rev : 0.20  2003.04.22  \[Xt@Cɏo͗p̊gq(lst/bas/pbf) */
/*                          w肵ꍇ̖CB                */
/*                          G[BbZ[WÓ    */
/*  Rev : 0.21  2003.04.25  PST TS,xx,GST TS,$ǉB                  */
/*  Rev : 0.22  2003.04.26  ߃R[h(0xD2`0xDB)ɑ΂Jumpg֎~  */
/*                          (DIDM,DIUM,BYDM,BYUM,INVM,CMPM)             */
/*  Rev : 0.23  2003.05.15  /SETIvVǉ                        */
/*  Rev : 0.24  2003.05.25  CODE̖\[XɑΉB                    */
/*                          SpXy[X𖳎悤ɂB          */
/*  Rev : 0.25  2003.05.29  Iyh̗\񕶎ȂB  */
/*  Rev : 0.26  2003.06.26  VOR[e[VwT|[g        */
/*  Rev : 0.27  2003.06.29  #includeŃtpXwǉ              */
/*  Rev : 0.28  2003.07.25  ΃Wv͈̓`FbNC          */
/*                          R}hC̉ǁB                  */
/*                          /SETIvVsvɂB                */
/*                          Xgo͎TABw(/tab)ǉB         */
/*  Rev : 0.29  2003.09.01  PBFo͎ɃS~cꍇ̂C     */
/*  Rev : 0.30  2003.09.10  START錾̂\[X́AgqEXEŏo  */
/*                          悤ɏC                              */
/*  Rev : 0.31  2003.09.14  R[e[V̊"()"C        */
/*                          RpCɃ[jOoĂ̂C  */
/*  Rev : 0.32  2004.01.16  "JR"^O̎w肪OPR2łłȂ̂C      */
/*  Rev : 0.33  2004.12.24  V{xo^(EQU)ǁB         */
/*                          E1pXڂɒlm肵ĂȂxłp */
/*                            \Ƃ                                */
/*                          EV{o^̃G[bZ[WC    */
/*                          IyhZ                    */
/*                          E\g悤ɂ                */
/*                          /qIvVǉ                            */
/*                          ENCbN[_`T|[g              */
/*  Rev : 0.34  2006.06.12  #INCBIN[߂ǉB                     */
/*                          oCi/BMPǂݍ݂T|[gB            */
/*  Rev : 0.34  2006.09.01  PSR/GSRߌQɑΉB                       */
/*                          CfbNXWX^(SX,SY,SZ)ɂ    */
/*                          CWX^\L( $(SX)/$(SY)/$(SZ) )ǉ */
/*                          $SX,$SY,$SZ\L\ƂB               */
/*  Rev : 0.35  2006.09.09  jjbNύX(SNL->LDL)                  */
/*              2006.09.10  bZ[WC                            */
/*  Rev : 0.36  2006.09.25  LDM/STM߂LDD/STD(KC`)ɐUւꂽ*/
/*                          ꍇA[jO\悤ɂB        */
/*                          #KC,#AI^߂ǉB                     */
/*  Rev : 0.37  2006.09.30  o[Wԍ̏CRev0.360.37           */
/*                          /wIvVǉB16rbgAhXɑΉB*/
/*              2006.10.02  fobOR[h폜iɉeȂj      */
/*  Rev : 0.38  2006.11.06  VtgZǉBׂoOCB        */
/*                          RpCIvV(WITH_EOF)ǉB        */
/*  Rev : 0.39  2006.11.08  % ](MOD)̗D揇ʂύXB(Cꏀ)    */
/*  Rev : 0.40  2007.03.16  /rIvVwɂăP[gt@C  */
/*                          (*.roc)o͂悤ɂB               */
/*                          /o [t@C] ɂ*.bas/*pbfɏo͂    */
/*                          t@Cwł悤ɂB          */
/*  Rev : 0.41  2008.05.05  Europe`jjbN(casio original?)ǉB */
/*                          /eu IvVсA[ #euǉB    */
/*  Rev : 0.42  2011.01.03  /rIvV                        */
/*                          (1)EQUxo^Ƀxʂp    */
/*                          (2)ORGpxAhXʂɍēo^  */
/*                          (3)DW߂.roct@C̏o͑ΏۂƂ     */
/*                          AZux(outtbl.kindǉɂ) */
/*  Rev : 0.43  2011.01.07  /rIvV                        */
/*                          RR`Ver.2Ή                             */
/*  Rev : 0.44  2021.07.09  unsigned long -> unsigned int ɕύX        */
/*                          EOFIvV𖳌(DOSł͕ύXȂ)      */
/*                          EOFERR(t@CI)͐IƂ      */
/*                          /sIvVǉ                        */
/*                          DL-PASCALpinline`o͂ǉ           */
/*  Rev : 0.45  2022.09.12  2pXڂOutBuf@C             */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include"hd61700.h"
/*------------------------------------------------------------------*/
/*  萔`                                                        */
/*------------------------------------------------------------------*/
#if __FORDOS
char	name[]	="HD61700 ASSEMBLER FOR DOS ";	/* AZu   */
#else
char	name[]	="HD61700 ASSEMBLER ";	/* AZu           */
#endif
char	rev[]	="Rev 0.45";			/* Revision                 */
/* p\ */
char	LabelStr[]	= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789@_";
char	DecStr[]	= "0123456789";
char	HexStr[]	= "0123456789ABCDEFabcdef";
/*------------------------------------------------------------------*/
/*  ϐ`                                                        */
/*------------------------------------------------------------------*/
char	SrcFile[MAXLINE];			/* \[Xt@C             */
char	IncFile[MAXLINE];			/* CN[ht@C       */
char	BinFile[MAXLINE];			/* oCit@C           */
char	LstFile[MAXLINE];			/* Xgt@C             */
char	OutFile[MAXLINE];			/* o̓t@C               */
char	ExeFile[MAXLINE];			/* st@C               */
char	RocFile[MAXLINE];			/* AP[gt@C   */
FILE	*IncFD[MAXINC];				/* INCLUDEt@CfBXNv^*/
FILE	*SrcFD;						/* \[Xt@CfBXNv^ */
FILE	*BinFD;						/* Binaryt@CfBXNv^ */
FILE	*LstFD;						/* Xgt@CfBXNv^ */
FILE	*OutFD;						/* o̓t@CfBXNv^   */
FILE	*RocFD;						/* roct@CfBXNv^    */
unsigned short	pass;				/* AZupX(0A1)       */
unsigned short	SetLabel;			/* /SET IvVo^        */
SETOPT			SetTbl[MAXOPT];		/* /SETIvV\         */
unsigned short	DefInstMode;		/* 0:AI`A1:KC`A2:EU` */
unsigned short	InstMode;			/* 0:AI`A1:KC`A2:EU` */
unsigned short	DefUndefOpr;		/* 1:JIvVI()   */
unsigned short	UndefOpr;			/* 1:JIvVI       */
unsigned short	OutType;			/* 0:BASICA1:PBF`           */
unsigned short	pr;					/* ʏo̓tO               */
unsigned short	Tab;				/* TABo̓tO                */
unsigned short	OutRealloc;			/* 1:P[go         */
unsigned short	ExeName;			/* 0:ȂA1:o̓t@CwL */
#if __WORD_ADDRESS
unsigned short	Wadr;				/* 1:16Bit AddressingΉ       */
#endif
unsigned int 	StartAdr;			/* AZuJnAhX       */
unsigned int 	ExecAdr;			/* sJnAhX             */
unsigned int 	AsmAdr;				/* AZuAhX           */
unsigned short	StartAdrFlag;		/* AZuJnAhXtO */
unsigned short	ExecAdrFlag;		/* sJnAhXtO       */
unsigned short	LabelCnt;			/* xo^                 */
LBL				* LabelTbl;			/* xo^e[u|C^   */
struct	outtbl	OutTbl;				/* \͌ʃe[u         */
unsigned char*	OutBuf;				/* ߏo̓obt@|C^     */
char			calcwk[MAXLINE+2];	/* xZobt@           */
int				CalcPtr;			/* Zobt@|C^         */
unsigned short	Ckind;				/* Z̖̉tO       */
int				IfLevel;			/* #if`#endif x           */
unsigned char	LblFlg;				/* xʏ(0:EQU,1:ADR)  */
unsigned char	AsmFlag;			/* AZu֎~/          */
unsigned char	IfStk[IFLEVEL];		/* AZu֎~/X^bN  */
unsigned short	ListFlag;			/* Xgo̓tO(0:o)     */
unsigned short	LineFeed;			/* #ejectvtO(1:v) */
unsigned short	IncLevel;			/* INCLUDEx(x1܂ŉ) */
unsigned short	SrcLine;			/* \[XXgsԍ           */
unsigned short	IncLine[MAXINC];	/* CN[hXgsԍ     */
char 			oprwk[MAXLEN+2];	/* jjbN/Iyhp[N*/
									/* rpɒӂ邱     */

/*------------------------------------------------------------------*/
/*  vg^Cv錾                                                */
/*------------------------------------------------------------------*/
int main(int argc, char *argv[]);
int AsmProcess( char * );
int InitAsm( char * File );
void ClearFlag( void );
int AsmLine( void );
int AsmCodeSet( void );
int SearchOpr( unsigned short op1 ,unsigned short op2 ,unsigned short op3 ,unsigned short op4 );
int GetJumpData( unsigned short jadr , unsigned short adr  , unsigned short byte ,unsigned short *op ,unsigned short *opdat );
int GetIndexKind( char * buff , unsigned short * kind , unsigned short * data ,unsigned short *si);
int GetOprKind( int num , char * buff , unsigned short * kind , unsigned short * data ,unsigned short *si );
int SetLabelTbl( char * buff , unsigned short adr , unsigned char flag );
int GetLabelAdr( char * buff , unsigned short * adr );
int GetIRegKind( char * buff , unsigned short * kind );
int GetFlagKind( char * buff , unsigned short * kind );
int GetMacKind( char * buff );
unsigned short GetMnemonicKind( char * buff );
int CheckLabel( char * buff );
int ChgCode( char * dst , char * src );
int ChgKcName( char * dst , char * src );
#if __EUR_MNEMONIC
int ChgEuropeName( char * dst , char * src );
#endif /* __EUR_MNEMONIC */
int GetReg( char * buff , unsigned short * data ,unsigned short * sir);
int GetLine( FILE *fd ,char *buff );
int GetParam( char *buff );
int GetData( char *buff , unsigned short * data );
int GetCalcData( char * buff , unsigned short * kind ,unsigned short * adr );
int CalcVal(unsigned short * value );
int CalcVal0(unsigned short * value );
int CalcValShift(unsigned short * value );
int CalcVal1(unsigned short * value );
int CalcVal2(unsigned short * value );
int CalcVal3( unsigned short *value );
int GetValue(unsigned short *value );
int CheckSetOpt( char * name );
int CheckSetLbl( char * name ,unsigned short sts );
int IncludeBin( unsigned short *cnt ,char *File );
int ReadBin( unsigned int * Size );
int ReadBmp( unsigned int * Size );
void PrintList( int cnt );
void ErrPut( int cnt , int err );

/**********************************************************************/
/*   main    : main routine                                           */
/*                                                                    */
/*       : C                                             */
/*       : R}hCIvV                               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int main(int argc, char *argv[])
{
int	rc,i;
char * ptr;

	/* No[W̕\ */
	printf( "%s%s\n",name,rev );

	/* R}hC̃`FbN */
	if( argc > (MAXOPT*2) ){
		printf("Invalid Parameters.\n");
		exit(1);
	}

	/* \[Xt@Cw肠 */
	if ( !argv[1] ){
		printf("Invalid Source File Name.\n");
		exit (1);
	}
	/* t@C̍쐬 */
	sprintf( SrcFile , "%s" , argv[1] );

	/* SETIvV */
	SetLabel = 0;
	memset( oprwk , 0 , MAXLEN+2 );
	memset( SetTbl , 0 , sizeof(SetTbl) );

	/* IvV */
	pr = 0;
	Tab = 0;
	DefUndefOpr = 1;
	OutType = 0;
	DefInstMode = 0; /* AI`I */
	OutRealloc = 0;
	ExeName = 0;
#if __WORD_ADDRESS
	Wadr = 0;
#endif
	/* NIvV擾 */
	i=2;
	while( argv[i] ){
#if __EUR_MNEMONIC
		/* ftHgjjbN[hݒ */
		if (!strcmp("/ai",argv[i])||!strcmp("/AI",argv[i])){ DefInstMode = 0;i++; continue; }
		if (!strcmp("/kc",argv[i])||!strcmp("/KC",argv[i])){ DefInstMode = 1;i++; continue; }
		if (!strcmp("/eu",argv[i])||!strcmp("/EU",argv[i])){ DefInstMode = 2;i++; continue; }
#endif /* __EUR_MNEMONIC */
#if __WORD_ADDRESS
		/* 16rbgAhbVOI */
		if (!strcmp("/w",argv[i])||!strcmp("/W",argv[i])){ Wadr = 1;i++; continue; }
#endif
		/* P[go͑I */
		if (!strcmp("/r",argv[i])||!strcmp("/R",argv[i])){ OutRealloc = 1;i++; continue; }
		/* TABXgo͑I */
		if (!strcmp("/tab",argv[i])||!strcmp("/TAB",argv[i])){ Tab = 1;i++; continue; }
		/* SIRœKOFFAZuI(LEVEL 0) */
		if (!strcmp("/n",argv[i])||!strcmp("/N",argv[i])){ DefUndefOpr = 0;i++; continue; }
		/* PBFt@Co͑I */
		if (!strcmp("/p",argv[i])||!strcmp("/P",argv[i])){ OutType = 1;i++; continue; }
		/* QLt@Co͑I */
		if (!strcmp("/q",argv[i])||!strcmp("/Q",argv[i])){ OutType = 2;i++; continue; }
#if __DLP_INLINE
		/* DL-Pascal inline() format */
		if (!strcmp("/s",argv[i])||!strcmp("/S",argv[i])){ OutType = 3;i++; continue; }
#endif
		/* bas/pbft@Cw */
		if (!strcmp("/o",argv[i])||!strcmp("/O",argv[i])){
			/* p[^ */
			if( !argv[++i] || argv[i][0]=='/' ){
				/* R}hCُ */
				printf("Invalid /O Parameters.\n");
				exit(1);
			}
			/* bas/pbfpt@Cw肷 */
			sprintf(ExeFile,"%s",argv[i++]);
			ExeName = 1;
			continue;
		}
		/* SETIvV */
		if (!strcmp("/set",argv[i])||!strcmp("/SET",argv[i])){
			/* p[^ */
			if( !argv[++i] ){
				/* R}hCُ */
				printf("Invalid /SET Parameters.\n");
				exit(1);
			}
		}
		/***********************/
		/* o^    */
		/***********************/
		/* R}hCo */
		sprintf( oprwk , "%s" , argv[i] );
		/* "=" */
		if ((ptr = strrchr( oprwk , '=' ))){
			if( ((int)(ptr - oprwk ) > MAXNAME )||( strlen(ptr) > (MAXNAME+1) ) ){
				/* R}hCُ */
				printf("Invalid /SET name.\n");
				exit(1);
			}
			/* o^x̎擾 */
			memcpy(SetTbl[SetLabel].ent,oprwk,(int)(ptr-oprwk));
			/* 擾 */
			sprintf(SetTbl[SetLabel].let,"%s", ptr+1 );
			/* =Eӂ܂́AV{o^ȂG[IƂ */
			if (!strcmp(SetTbl[SetLabel].ent,SetTbl[SetLabel].let)||!CheckSetOpt( SetTbl[SetLabel].ent ) ){
				/* R}hCُ */
				printf("Invalid /SET name.\n");
				exit(1);
			}
			/* 16i\L0x&HɏC */
			if( !memcmp(SetTbl[SetLabel].let,"0x",2)||!memcmp(SetTbl[SetLabel].let,"0X",2) ){
				SetTbl[SetLabel].let[0]='&';
				SetTbl[SetLabel].let[1]='H';
			}
			/* SETV{XV */
			SetLabel++;
			i++;
			continue;
		}
		/* R}hCُ */
		printf("Invalid Parameters.\n");
		exit(1);
	}
#if __WORD_ADDRESS
	/* œK֎~ */
	if (Wadr) UndefOpr = 0;
#endif
	/* AZu */
	rc = AsmProcess( SrcFile );

	return(rc);
}

/**********************************************************************/
/*   InitAsm : Initialize Assembler Process                           */
/*                                                                    */
/*       : AZu                                   */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int InitAsm( char * File )
{
char * fptr;
char out[8];
	/* t@CfBXNv^ */
	SrcFD = 0;
	BinFD = 0;
	LstFD = 0;
	OutFD = 0;
	RocFD = 0;
	/* o̓obt@|C^ */
	OutBuf = 0;
	/* etO/JE^ */
	ClearFlag();
	/* LABELe[u */
	LabelCnt = 0;
	LabelTbl = 0;
	/* t@C̍쐬 */
	sprintf( LstFile , "%s" , File );
	sprintf( OutFile , "%s" , File );

	if ( !ExeName ){
		/* st@C쐬 */
		if(fptr = strrchr(File,  0x5c ))
			ChgCode( ExeFile , &fptr[1] );
		else ChgCode( ExeFile , File );
	}

	/* Listt@C쐬 */
	if ((fptr = strrchr(LstFile,  '.' )))
		sprintf( fptr,".lst" );
	else	strcat( LstFile, ".lst" ); 

	/* o̓t@C쐬 */
	switch ( OutType ){
	case 0:
		sprintf( out ,".bas" );
		break;
	case 1:
		sprintf( out ,".pbf" );
		break;
	case 2:
		sprintf( out ,".ql" );
		break;
#if __DLP_INLINE
	case 3:
		sprintf( out ,".pas" );
		break;
#endif
	}
	if ((fptr = strrchr(OutFile, '.' )))
		sprintf( fptr,"%s", out );
	else	strcat( OutFile, out );

	/* AP[gt@C쐬vL */
	if ( OutRealloc ){
		sprintf( RocFile , "%s" , File );
		/* AP[gt@C쐬 */
		if ((fptr = strrchr(RocFile,  '.' )))
			sprintf( fptr,".roc" );
		else	strcat( RocFile, ".roc" );
	}

	/* ̓t@Clst/bas/pbfw̏ꍇAG[I */
	if( !strcmp(OutFile,SrcFile) || !strcmp(LstFile,SrcFile) ){
		printf("Invalid Source File Name.\n");
		return INZERR;
	}
	/* \[Xt@COPEN */
	if ( ( SrcFD = fopen( SrcFile ,"rb" ) ) <= 0 ){
		printf("Invalid Source File Name.\n");
		return INZERR;
	}
	printf( "Input : %s \n", SrcFile );
	/* t@CWȏ̏ꍇA[jO\ */
	if ( (strrchr(ExeFile, '.' ) - ExeFile ) > 8 ){
		printf("Warning! File Name Over 8 Chracters.\n");
	}
	return NORM;
}

/**********************************************************************/
/*   ClearFlag : Clear Flag Data                                      */
/*                                                                    */
/*       : etO                                       */
/*       : Ȃ                                                   */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void ClearFlag( void )
{
	/* AZuJnAhX */
	SrcLine = 0;
	ListFlag = 0;
	LineFeed = 0;
	IncLevel = 0;
	AsmAdr = 0;
	ExecAdr = 0;
	StartAdr = 0;
	StartAdrFlag = 0;
	ExecAdrFlag = 0;
	/* AZu */
	AsmFlag = 0;
	/* #iflXgx */
	IfLevel = 0;
	/* #if`#endifX^bN */
	memset( IfStk , 0 , sizeof(IfStk) );
	/* #include񏉊 */
	memset( IncLine , 0 ,sizeof(IncLine));
	memset( IncFD , 0 , sizeof(IncFD));
}

/**********************************************************************/
/*   AsmProcess : Assembler Process Main Routine                      */
/*                                                                    */
/*       : AZu                                         */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int AsmProcess( char * File )
{
char mnwk[MAXMN];	/* jjbNϊp[N */
char * fptr;
char out[8];
int rc,rc2,i,n;
unsigned short	op;
unsigned short	sum,sts,line;
unsigned short	LineCnt;	/* sԍJE^ */
unsigned int	OutCnt,cnt;	/* o̓oCg */
unsigned int	BuffSize;	/* o̓obt@TCY */

	LBL *Label;
LBL *Labelwk;
	/* ݒ */
	if( rc = InitAsm( File ) ) return rc;

	/* SETIvVs(ml̂݃V{o^) */
	if ( SetLabel ){
		/* xo^s */
		for ( i = 0 ; i < SetLabel ; i++ ){
			/* l擾 */
			if( !( rc = GetData( SetTbl[i].let , &sts ) ) ){
				/* x`FbN */
				if ( rc = CheckLabel( SetTbl[i].ent ) ){
					/* G[\ */
					printf("Invalid /SET name.\n");
					goto asm_end;
				}
				/* xe[uɓo^ */
				if(rc = SetLabelTbl( SetTbl[i].ent , sts ,LBL_EQU )){
					/* G[\ */
					printf("Invalid /SET name.\n");
					goto asm_end;
				}
			}
			/* l̓xł */
			else{
				/* x`FbN */
				if ( rc = CheckLabel(SetTbl[i].let) ){
					/* G[\ */
					printf("Invalid /SET name.\n");
					goto asm_end;
				}
			}
		}
	}
	/* Xgt@COPEN */
	if ( ( LstFD = fopen( LstFile ,"w" ) ) <= 0 ){
		printf("File Create Error.\n");
		goto asm_end;
	}

	/* PpXڃxe[u쐬 */
	UndefOpr = DefUndefOpr;
	InstMode = DefInstMode;
	LineCnt = 0;
	pass = 0;
	while( !rc ){
		rc = AsmLine();
#if __WORD_ADDRESS
		/* 16bit addressingɕϊ */
		if (Wadr){
			/* AhX␳ */
			AsmAdr -= OutTbl.byte;
			OutTbl.byte = (OutTbl.byte+1)&0xfe;
			AsmAdr += (OutTbl.byte/2);
		}
#endif
		if ( rc && (rc != EOFERR) ) {
			/* G[\ */
			ErrPut( LineCnt , rc );
			goto asm_end;
		}
		/* sԍXV */
		LineCnt = !IncLevel ? ++SrcLine : ++IncLine[IncLevel-1];
	}
	/* #if`#enfiflXgُ픭 */
	if ( IfLevel ){
		/* G[\ */
		ErrPut( LineCnt-1 , IFNEST );
		goto asm_end;
	}
#if __WORD_ADDRESS
	/* o̓TCY߂ */
	OutCnt = Wadr ? (AsmAdr*2) : AsmAdr;
#else
	OutCnt = AsmAdr;
#endif
	/* R[h͍őobt@͈͓Ɏ܂ */
	if ( (BuffSize = (OutCnt - StartAdr) ) > MAXOBJ ){
		/* o̓obt@I[o[ */
		ErrPut( LineCnt-1 , AOFLOW );
		goto asm_end;
	}
	/* \[Xt@C擪ɃV[N */
	if( fseek(SrcFD , 0 , SEEK_SET )){
		printf("Source File Seek Error.\n");
		goto asm_end;
	}
	/* PpXڏI */
	printf( " PASS 1 END \n" );

	/* o̓obt@mۂ(1Byte]Ɏ) */
	if ( !( OutBuf = malloc( (size_t)(BuffSize+1) ) ) ){
		printf("Output Buffer Not Allocated.\n");
		goto asm_end;
	}
	/* o̓obt@ */
	for( i = 0 ; i < BuffSize ; i++ ){
		OutBuf[i] = 0;
	}

	/* sԍAAZuAhXA[h */
	ClearFlag();
	UndefOpr = DefUndefOpr;
	InstMode = DefInstMode;
	LineCnt = 0;
	OutCnt = 0;

	/* Xgo͊Jn */
	fprintf( LstFD , "%s%s - ",name,rev );
	fprintf( LstFD ,"ASSEMBLY LIST OF [%s]\n", SrcFile );

	/* P[gt@C쐬vL */
	if ( OutRealloc ){
		/* Xgt@COPEN */
		if ( ( RocFD = fopen( RocFile ,"w" ) ) <= 0 ){
			printf("Roc File Create Error.\n");
			goto asm_end;
		}
		/* wb_o */
		fprintf(RocFD,"DW &H0000\n" );
		fprintf(RocFD,"DW &HFFFF\n" );
		/* oCg */
		n = 4;
	}

	/* QpXڃxAhX𔽉fA߃R[ho͂ */
	rc = 0; rc2 = 0;pass++;
	while( !rc && !rc2 ){
		rc = AsmLine();
#if __WORD_ADDRESS
		/* 16bit addressingɕϊ */
		if (Wadr){
			/* AhX␳ */
			AsmAdr -= OutTbl.byte;
			OutTbl.byte = (OutTbl.byte+1)&0xfe;
			AsmAdr += (OutTbl.byte/2);
		}
#endif
		if ( rc && (rc != EOFERR) ) {
			/* G[\ */
			ErrPut( LineCnt , rc );
			goto asm_end;
		}
		/* AZuԂ̎̂ݎs */
		if (!AsmFlag){
			if ( rc2 = AsmCodeSet() ){
				ErrPut( LineCnt , rc2 );
				goto asm_end;
			}
			/* R[h̓obt@͈͓Ɏ܂ */
			if ( ( OutCnt + (unsigned int)OutTbl.byte ) > BuffSize ){
				/* o̓obt@I[o[ */
				ErrPut( LineCnt , AOFLOW );
				goto asm_end;
			}
			/* AI`[hȂLDM/STM[jO\*/
			if( !InstMode && OutTbl.sts ){
				pr = 1;
				printf("LINE ");
				/* Xgt@Co */
				PrintList( LineCnt );
				/* [NGA */
				memset( mnwk , 0 , sizeof(mnwk) );
				/* ̓jjbN */
				ChgCode( mnwk , OutTbl.opr[0] );
				mnwk[2] = 'D';
				printf("WARNING: '%s' was interpreted to '%s' of the KC form.\n",OutTbl.opr[0],mnwk);
				pr = 0;
			}
			else{
				/* Xgt@Co */
				PrintList( LineCnt );
			}
			/* R[ho͗v */
			if ( OutTbl.byte ){
				/* ʏ햽߁^^ߎʂɂ镪 */
				switch( OutTbl.kind ){
				/* ORG/DS */
				case OP_ORG:
				case OP_DS:
					break;
				/* #INCBIN */
				case OP_INCBIN:
					/* oCiR[ho */
					memcpy( &OutBuf[OutCnt] , OutTbl.bcode , OutTbl.byte );
					/* obt@J */
					free( OutTbl.bcode );
					break;
				default:
					/* ORG/DS/#INCBIN ߈ȊOȂAf[^o */
					memcpy( &OutBuf[OutCnt] , OutTbl.code , OutTbl.byte );
					/* P[gt@C쐬vL */
					if ( OutRealloc ){
						/* DW^߂ł */
						if( OutTbl.kind == OP_DW ){
							cnt = 0;
							i = 0;
							/* IyhGgo^ */
							while( OutTbl.opr[cnt+1] ){
								/* 擪OPRȊÓAJ}̃`FbN */
								if ( cnt ){
									/* 擪XLbv */
									i = 1;
								}
								/* xʏ */
								LblFlg = 0;
								/* vZƂď */
								if( !GetCalcData( OutTbl.opr[cnt+1]+i , &op , &sts ) ){
									/* AhXxłAR[h͈͓ł */
									if(( LblFlg == LBL_ADR )&&((unsigned short)StartAdr<=sts)&&((unsigned short)(StartAdr+BuffSize)>sts))
									{
										op = sts - (unsigned short)StartAdr;
										sts= OutTbl.adr + (cnt<<1) - (unsigned short)StartAdr;
										/* .roct@Co */
										fprintf(RocFD,"DW &H%04X,&H%04X\n",sts, op );
										/* oCgXV(+4) */
										n += 4;
									}
								}
								cnt++;
							}
							break;
						}
						/* ʖ߈ȊOł */
						if( OutTbl.kind != UNDEFOPR ){
							break;
						}
						/* xʏ */
						LblFlg = 0;
						/* ߌɂ镪 */
						switch( OutTbl.code[0] ){
						/* JP IM16 */
						case 0x30: case 0x31: case 0x32: case 0x33:
						case 0x34: case 0x35: case 0x36: case 0x37:
						/* CAL IM16 */
						case 0x70: case 0x71: case 0x72: case 0x73:
						case 0x74: case 0x75: case 0x76: case 0x77:
						/* LDW $,IM16 /PRE Reg,IM16 */
						case 0xD1: case 0xD6: case 0xD7:
							i = ( OutTbl.code[0]==0x37 || OutTbl.code[0]==0x77 ) ? 1 : 2;
							if( !GetCalcData( &OutTbl.opr[i][(i==2)?1:0], &op , &sts ) ){
								/* AhXxłAR[h͈͓ł */
								if(( LblFlg == LBL_ADR )&&((unsigned short)StartAdr<=sts)&&((unsigned short)(StartAdr+BuffSize)>sts))
								{
									/* 4oCg߂ȂIyh2A3oCg߂ȂIyh1ǂݏo */
									i = ( OutTbl.byte == 4 ) ? 2 : 1;
									op =((unsigned short)OutTbl.code[i]|(unsigned short)OutTbl.code[i+1]<<8)-(unsigned short)StartAdr;
									sts =  OutTbl.adr - (unsigned short)StartAdr +i;
									/* .roct@Co */
									fprintf(RocFD,"DW &H%04X,&H%04X\n",sts, op );
									/* oCgXV(+4) */
									n += 4;
								}
							}
							break;
						default:
							break;
						}
					}
					break;
				}
			}
			/* o̓oCgXV */
			OutCnt += OutTbl.byte;
		}
		else if (AsmFlag==1){
			/* Xgt@Co */
			PrintList( LineCnt );
			AsmFlag++;
		}
		/* sԍXV */
		LineCnt = !IncLevel ? ++SrcLine : ++IncLine[IncLevel-1];
	}
	/* AZuI */
	printf( " PASS 2 END\n" );
	printf("ASSEMBLY COMPLETE, NO ERRORS FOUND\n");
	fprintf(LstFD,"\nASSEMBLY COMPLETE, NO ERRORS FOUND\n");

	/* xe[uo͂ */
	if ( LabelCnt ){
		/* wb_o */
		fprintf( LstFD ,"\n%s%s - ",name,rev );
		fprintf( LstFD ,"MAP LIST OF [%s]\n", SrcFile );
		fprintf( LstFD ," LABEL           : ADDRESS(hex)  | LABEL           : ADDRESS(hex)\n" );
		fprintf( LstFD ,"-------------------------------------------------------------------\n" );
		Label = LabelTbl;
		i = 0;
		while ( Label ){
			if (!(i&1))	fprintf( LstFD ," %-16s:   %04Xh     %s |" , Label->name , Label->adr ,(Label->flag==LBL_ADR?"A":" "));
			else fprintf( LstFD ," %-16s:   %04Xh      %s\n" , Label->name , Label->adr,(Label->flag==LBL_ADR?"A":" ") );
			Label = Label->np;
			i++;
		}
		if (i&1) fprintf( LstFD ,"\n");
	}
	/* AZuo */
	fprintf( LstFD ,"\n START ADDRESS   = %04Xh\n", StartAdr );
	fprintf( LstFD ," END ADDRESS     = %04Xh\n", AsmAdr-1 );
	fprintf( LstFD ," EXECUTE ADDRESS = %04Xh\n", ExecAdr );

	/* P[gt@C쐬vL */
	if ( OutRealloc ){
		/* t@Ceʏo */
		fprintf(RocFD,"DW &H%04X\n",OutCnt+n+2 );
		/* sAhXΈʒuiwb_擪jo */
		fseek(RocFD,0,SEEK_SET);
		fprintf(RocFD,"DW &H%04X\n", (ExecAdrFlag ? (unsigned short)(ExecAdr-StartAdr) : 0) );
	}

	/* o̓t@C쐬 */
	if ( OutCnt ){
#if __WORD_ADDRESS
		/* f[^ó͎AIAhXɖ߂ */
		if (Wadr) AsmAdr *= 2;
#endif
		/* o͗pt@COPEN */
		if ( ( OutFD = fopen( OutFile ,"w" ) ) <= 0 ){
			printf("File Create Error.\n");
			goto asm_end;
		}
		if ( !ExeName ){
			/* st@C쐬 */
			if ( !ExecAdrFlag ) sprintf( out ,".BIN" );
			else sprintf( out ,".EXE" );
			if ((fptr = strrchr(ExeFile, '.' ))) sprintf( fptr ,"%s" ,out );
			else strcat( ExeFile ,out );
		}
		/* t@C쐬 */
		switch( OutType ){
		/* bast@C쐬 */
		case 0:
			line = 999;
#if __FORDOS
			fprintf( OutFD ,"%d DATA %s,&H%X,&H%X,&H%X\n", line++,ExeFile,(unsigned short)StartAdr,(unsigned short)(AsmAdr-1),(unsigned short)ExecAdr );
#else
			fprintf( OutFD ,"%d DATA %s,&H%X,&H%X,&H%X\n", line++,ExeFile,StartAdr,AsmAdr-1,ExecAdr );
#endif
			for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
				/* sԍo */
				if (!n) fprintf( OutFD ,"%d DATA ", line++ );
				fprintf( OutFD ,"%02X", OutBuf[cnt] );
				sum += OutBuf[cnt];
				n++;
				/* `FbNT/so */
				if ( n >= 8 ){
					fprintf( OutFD ,",%02X\n", sum&0xff );
					n = 0;
					sum = 0;
				}
			}
			/* `FbNTo */
			if (n) fprintf( OutFD ,",%02X\n", sum&0xff );
			break;
		/* pbft@C쐬v */
		case 1:
#if __FORDOS
			fprintf( OutFD ,"%s,%u,%u,%u\n", ExeFile,(unsigned short)StartAdr,(unsigned short)(AsmAdr-1),(unsigned short)ExecAdr );
#else
			fprintf( OutFD ,"%s,%u,%u,%u\n", ExeFile,StartAdr,AsmAdr-1,ExecAdr );
#endif
			for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
				fprintf( OutFD ,"%02X", OutBuf[cnt] );
				sum += OutBuf[cnt];
				n++;
				/* `FbNT/so */
				if ( n >= 120 ){
					fprintf( OutFD ,",%u\n", sum );
					n = 0;
					sum = 0;
				}
			}
			/* `FbNTo */
			if (n) fprintf( OutFD ,",%u\n", sum );
			break;
		/* NCbN[_t@C쐬 */
		case 2:
			line = 1000;
#if __FORDOS
			fprintf( OutFD ,"%d DATA %u,%u,%u\n", line++,(unsigned short)StartAdr,(unsigned short)(AsmAdr-1),(unsigned short)ExecAdr );
#else
			fprintf( OutFD ,"%d DATA %u,%u,%u\n", line++,StartAdr,AsmAdr-1,ExecAdr );
#endif
			for ( cnt = 0 , n = 0 ; cnt < OutCnt ; cnt ++ ){
				/* sԍo */
				if (!n) fprintf( OutFD ,"%d DATA ", line++ );
				fprintf( OutFD ,"%02X", OutBuf[cnt] );
				n++;
				if ( n >= 24 ){
					fprintf( OutFD ,"\n" );
					n = 0;
					continue;
				}
				/* J}o */
				if ( !( n % 6 ) ) fprintf( OutFD ,"," );
			}
			/* c0o */
			while( n && ( n < 24 ) ){
				fprintf( OutFD ,"00" );
				n++;
				if ( n == 24 ){
					fprintf( OutFD ,"\n" );
					break;
				}
				/* J}o */
				if ( !( n % 6 ) ) fprintf( OutFD ,"," );
			}
			break;
#if __DLP_INLINE
		/* DL-Pascal inline() format o */
		case 3:
			/* wb_o */
			fprintf(OutFD,"inline(\n");
			for ( cnt = 0 , n = 0 ; cnt < OutCnt ; cnt ++ ){
				if ( n == 0 ) {
				    fprintf( OutFD, "\t");
				}
				fprintf( OutFD ,"$%02X", OutBuf[cnt] );
				/* ŏIf[^̓J}tȂ */
				if( cnt < ( OutCnt - 1 ) ){
					fprintf( OutFD, ",");
				}
				n++;
				if ( n == 16 || cnt == ( OutCnt - 1 ) ){
					fprintf( OutFD ,"\n" );
					n = 0;
				}
			}
			fprintf(OutFD,");\n");
			break;
#endif
		}
#if __WITH_EOF
 #if __DLP_INLINE
		/* inline`o͎EOFtȂ */
		if( OutType != 3 )
 #endif
			/* EOFo */
			fprintf( OutFD ,"%c",0x1a);
#endif
		/* o̓t@CN[Y */
		fclose(OutFD);
	}

asm_end:
	/* P[gt@C쐬vL */
	if ( OutRealloc ){
		if (RocFD) fclose(RocFD);
	}
	/* xe[u */
	Label = LabelTbl;
	while ( Label ){
		Labelwk = Label->np;
		free( Label );
		Label = Labelwk;
	}
	/* o̓obt@ */
	if ( OutBuf ) free( OutBuf );
	/* INCLUDEt@CN[Y */
	if ( IncLevel ){
		for ( i = 0 ; i < IncLevel ;i++){
			fclose( IncFD[i] );
		}
	}
	/* t@CN[Y */
	if (SrcFD) fclose(SrcFD);
	if (LstFD) fclose(LstFD);

	/* t@CŏI(EOFERR)͐튮Ƃ */
	return (rc == EOFERR) ? NORM : rc;
}
/**********************************************************************/
/*   AsmLine : Assembler Process ( one line )                         */
/*                                                                    */
/*       : \[XsPsAZuAʂOutTblɊi[     */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int AsmLine( void )
{
FILE	*SourceFD;/* \[Xt@CfBXNv^ */
char Work[MAXLINE+2];/* sf[^擾p[N */
int  rc,i,n,cnt,len,opr,kc;
unsigned short	op,opdat,sts;
unsigned short	si = 0;

	/* G[Xe[^X */
	rc = 0;

	/* R[hϊobt@ */
	memset( &OutTbl.kind,0, sizeof(OUTTBL));
	OutTbl.kind = UNDEFOPR;
	
	/* s[Nobt@ */
	memset( Work , 0 , sizeof(Work) );

	/* ݂̃AZuAhXo^ */
	OutTbl.adr = (unsigned short)AsmAdr;

	/* t@C؂ւ */
	SourceFD = !IncLevel ? SrcFD : IncFD[IncLevel-1];

	/* \[Xt@CPso */
	rc = GetLine( SourceFD , Work );

	/* CN[ht@CI */
	if ( rc == EOFERR && IncLevel ){
		IncLevel--;
		fclose( IncFD[IncLevel] );
		IncFD[IncLevel] = 0;
		return NORM;
	}

	/* G[󔒍słꍇAI */
	if ( ( rc && ( rc!=EOFERR ) ) || !Work[0]) return rc;

	/* x/jjbN/Iyh/Rgɕ */
	if( rc = GetParam( Work ) ) return rc;

	/******************************************/
	/* #if`#else`#endif}N           */
	/******************************************/
	/* jjbNo^ */
	if ( OutTbl.opr[0] ){
		/* ^ߎʃ`FbN */
		ChgCode( oprwk , OutTbl.opr[0] );
		opr = GetMacKind( oprwk );
		switch( opr ){
		case OP_IF:
			/* xIyh2Gg */
			if ( OutTbl.label || OutTbl.opr[2] ) return ILLOPR;
			/* 1Iyhł */
			if( rc = GetCalcData( OutTbl.opr[1] , &op , &sts ) ) return rc;
			/* ̂ȏꍇAI */
			if ( op == LBLNG ) return LBLNOENT;
			/* lXgxAsmFlagۑ */
			IfStk[IfLevel] = AsmFlag;
			/* AZuԂł */
			if (!AsmFlag){
				/* AZu֎~/Zbg */
				AsmFlag = (unsigned char)(sts ? 0 : (!AsmFlag ? 1 : 2 ));
			}
			/* #iflXgx+1 */
			IfLevel++;
			/* lXgxI[o[ */
			if (IfLevel>=IFLEVEL) return IFNEST;
			return NORM;
		case OP_ELSE:
			/* xIyhGg */
			if ( OutTbl.label || OutTbl.opr[1] ) return ILLOPR;
			if ( !IfLevel ) return IFNEST;
			/* ʃlXg̓AZu */
			if ( !IfStk[IfLevel-1] ){
				/* AZuԔ] */
				AsmFlag = (unsigned char)(AsmFlag ? 0 : 1);
			}
			return NORM;
		case OP_ENDIF:
			/* xIyhGg */
			if ( OutTbl.label || OutTbl.opr[1] ) return ILLOPR;
			if ( !IfLevel ) return IFNEST;
			/* #iflXgx-1 */
			IfLevel--;
			if ( IfLevel < 0 ) return IFNEST;
			/* AZuĊJ */
			AsmFlag = IfStk[IfLevel];
			return NORM;
		default:
			break;
		}
	}
	/* AZu֎~Ȃ珈I */
	if ( AsmFlag ) return NORM;

	/******************************************/
	/* V{xo^                 */
	/******************************************/
	/* x */
	if ( OutTbl.label ){
		/* PpXڂł */
		if (!pass){
			/* x`FbN */
			if ( rc = CheckLabel(OutTbl.label) ) return rc;
			/* EQUvł */
			ChgCode( oprwk , OutTbl.opr[0] );
			if (!strcmp( "EQU" , oprwk )){
				/* IyhGgł */
				if ( !OutTbl.opr[1] || OutTbl.opr[2] ) return ILLOPR;
				/* xʂ𐔒l(EQU)wƂ */
				LblFlg = LBL_EQU;
				/* 1Iyhlł */
				if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
					/* ̂ȏꍇAV{o^Ȃ */
					if ( op == LBLNG ) return NORM;
					/* SETIvVs(ml̂݃V{o^) */
					if ( SetLabel ){
						/* x́A/SET̂ƈv */
						if ( (rc = CheckSetLbl( OutTbl.label, sts )) == 1 ) return NORM;
						/* xo^G[ */
						if ( rc ) return rc;
					}
					/* xe[uɓo^ */
					rc = SetLabelTbl( OutTbl.label, sts ,LblFlg );
				}
				/* sI */
				return rc;
			}
			/* EQUȊOł */
			else{
				if ( !StartAdrFlag ) { rc = NOORG; return rc; }/* ORGȂ */
				/* ݂̃AZuAhXxe[uɓo^ */
				if(rc = SetLabelTbl( OutTbl.label, (unsigned short)AsmAdr ,LBL_ADR )) return rc;
			}
		}
		/* QpXڂł */
		else{
			/* EQUvł */
			ChgCode( oprwk , OutTbl.opr[0] );
			if (!strcmp( "EQU" , oprwk )){
				/* ɓo^ς݂Ȃ甲 */
				if ( GetLabelAdr( OutTbl.label , &sts ) != LBLNOENT ) return NORM;
				/* xʂ𐔒l(EQU)wƂ */
				LblFlg = LBL_EQU;
				/* 1Iyhlł */
				if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
					/* ̂ȏꍇAI */
					if ( op == LBLNG ) return LBLNOENT;
					/* xe[uɓo^ */
					if ( (rc = SetLabelTbl( OutTbl.label, sts ,LblFlg )) ) return ILLLBL;
				}
				/* sI */
				return rc;
			}
		}
	}
	/******************************************/
	/* ^/ʖߏ                  */
	/******************************************/
	/* jjbNo^ */
	if ( OutTbl.opr[0] ){
		/* ʏ햽߁^^ߎʃ`FbN */
		ChgCode( oprwk , OutTbl.opr[0] );
		OutTbl.kind = GetMnemonicKind( oprwk );
		switch( OutTbl.kind ){
		case OP_EQU:
			/* xȂEQU(G[I) */
			if ( !pass ) rc = EQUNOLBL;
			break;
		case OP_ORG:
			/* ORG */
			/* QIyhȍ~ɓo^ꍇAG[I */
			if ( OutTbl.opr[2] ){
				rc = ILLOPR;
				break;
			}
			/* IyhGg */
			if ( !OutTbl.opr[1] ) return ILLOPR;
			/* PIyhlł */
			if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
				/* ̂ȏꍇAI */
				if ( op == LBLNG ){ rc = LBLNOENT; break; }
				if ( sts < (unsigned short)AsmAdr ){
					rc = OFLOW;
					break;
				}
				/* ݂̃AZuAhXXV */
				if ( !StartAdrFlag ){
					StartAdr = sts;
					StartAdrFlag = 1;
				}
				else{
					/* Qڈȍ~́AwoCgmۂ */
					OutTbl.byte = (unsigned short)( sts - (unsigned short)AsmAdr );
				}
				OutTbl.adr = sts;
				AsmAdr = sts;
			}
			break;
		case OP_START:
			/* START */
			/* QIyhȍ~ɓo^ꍇAG[I */
			if ( OutTbl.opr[2] ){
				rc = ILLOPR;
				break;
			}
			/* ExecAdrGg[ */
			if ( ExecAdrFlag ){
				rc = ILLSTART;
				break;
			}
			/* IyhGg */
			if ( !OutTbl.opr[1] ) return ILLOPR;
			/* PIyhlł */
			if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
				/* ̉ĂꍇAAhXo^ */
				if ( op == LBLOK ){
					/* AhXo^ */
					ExecAdr = sts;
					ExecAdrFlag = 1;
				}
				/* ̖ł2pXڂȂG[I */
				else if (pass){
					rc = LBLNOENT;
				}
			}
			break;
		case OP_DS:
			/* DS */
			if ( !StartAdrFlag ) { rc = NOORG; break; }/* ORGȂ */
			/* QIyhȍ~ɓo^ꍇAG[I */
			if ( OutTbl.opr[2] ){
				rc = ILLOPR;
				break;
			}
			/* PIyhlł */
			if( !(rc = GetCalcData( OutTbl.opr[1] , &op , &sts )) ){
				/* ̂ȏꍇAI */
				if ( op == LBLNG ){ rc = LBLNOENT; break; }
				/* woCgm */
				OutTbl.byte = sts;
				/* AhXXV */
				if (( AsmAdr + sts ) <= MAXOBJ ) AsmAdr += sts;
				else rc = ADOFLOW;
				break;
			}
			rc = ILLOPR;
			break;
		case OP_DB:
			/* DB */
			if ( !StartAdrFlag ) { rc = NOORG; break; }/* ORGȂ */
			/* PIyhȍ~ɓo^ȂꍇAG[I */
			if ( !OutTbl.opr[1] ){
				rc = ILLOPR;
				break;
			}
			cnt = 0;
			i = 0;
			n = 0;
			/* IyhGgo^ */
			while( OutTbl.opr[cnt+1] ){
				/* ȊÓAJ}̃`FbN */
				if ( cnt ){
					/* 擪J}ȊOłꍇAG[I */
					if ( *OutTbl.opr[cnt+1] != ',' ){
						rc = ILLCANMA;
						break;
					}
					/* 擪XLbv */
					i = 1;
				}
				/* ł */
				len = strlen( OutTbl.opr[cnt+1]+i );
				/* 擪эŏI̓R[e[V( = Gg)ł */
				if ( ((*(OutTbl.opr[cnt+1]+i) == 0x22 )&&(*(OutTbl.opr[cnt+1]+i+len-1) == 0x22 ))
					||((*(OutTbl.opr[cnt+1]+i) == 0x27 )&&(*(OutTbl.opr[cnt+1]+i+len-1) == 0x27 )) ){
					/* 񂪂RȉȂIyhُ */
					if( len < 3 ) {
						rc = ILLOPR;
						break;
					}
					/* R[ho^ */
					memcpy( &OutTbl.code[n] , OutTbl.opr[cnt+1]+i+1 , len-2 );
					n += ( len - 2 );
					rc = NORM;
				}
				else{
					/* vZƂď */
					if ( !(rc = GetCalcData( OutTbl.opr[cnt+1]+i , &op , &sts )) ) {
						/* ͈͊OȂG[ */
						if ( sts >= 256 ){
							rc = OFLOW;
							break;
						}
						/* R[ho^ */
						OutTbl.code[n++] = sts;
					}
					else break;
				}
				OutTbl.byte = (unsigned short)n;
				cnt++;
			}
			/* AhXXV */
			if (( AsmAdr + n ) <= MAXOBJ ) AsmAdr += n;
			else rc = ADOFLOW;
			break;
		case OP_DW:
			/* DW */
			if ( !StartAdrFlag ) { rc = NOORG; break; }/* ORGȂ */
			/* PIyhȍ~ɓo^ȂꍇAG[I */
			if ( !OutTbl.opr[1] ){
				rc = ILLOPR;
				break;
			}
			cnt = 0;
			i = 0;
			n = 0;
			/* IyhGgo^ */
			while( OutTbl.opr[cnt+1] ){
				/* ȊÓAJ}̃`FbN */
				if ( cnt ){
					/* 擪J}ȊOłꍇAG[I */
					if ( *OutTbl.opr[cnt+1] != ',' ){
						rc = ILLCANMA;
						break;
					}
					/* 擪XLbv */
					i = 1;
				}
				/* vZƂď */
				if ( rc = GetCalcData( OutTbl.opr[cnt+1]+i , &op , &sts ) ) break;
				/* [hPʂŃR[ho^ */
				OutTbl.code[n++] = (unsigned char)(sts & 0xff);
				OutTbl.code[n++] = (unsigned char)((sts>>8) & 0xff);
				OutTbl.byte = (unsigned short)n;
				cnt++;
			}
			/* AhXXV */
			if (( AsmAdr + n ) <= MAXOBJ ) AsmAdr += n;
			else rc = ADOFLOW;
			break;
		case OP_LEVEL:
			/* QIyhȍ~ɓo^ꍇAG[I */
			if ( OutTbl.opr[2] ){
				rc = ILLOPR;
				break;
			}
			/* PIyhlł */
			if ( !(rc = GetCalcData( OutTbl.opr[1] ,&op ,&sts )) ){
				/* ̂ȏꍇAI */
				if ( op == LBLNG ){ rc = LBLNOENT; break; }
				/* PB-1000݊R[h؂ւ */
				UndefOpr = (unsigned short)( sts ? 1 : 0 );
			}
			break;
		case OP_INCLUDE:
			/* ɃCN[ht@COPEN */
			if ( IncLevel >= (MAXINC-1) ){ rc = INCERR; break; }
			/* IyhGg */
			if ( !OutTbl.opr[1] ){ rc = ILLOPR; break; }
			if ( (len = strlen(OutTbl.opr[1])) < 3 ){ rc = INCNOFILE; break; }
			/* 擪эŏI͊ʂł */
			if ( ( OutTbl.opr[1][0] == '(' ) && ( OutTbl.opr[1][len-1] == ')' ) ){
				/* CN[ht@Co */
				memset( IncFile , 0 , sizeof(IncFile) );
				memcpy( IncFile , &OutTbl.opr[1][1] , len-2 );
				/* CN[ht@COPEN */
				if ( ( IncFD[IncLevel] = fopen( IncFile ,"rb" ) ) <= 0 ){ rc = INCNOFILE; break; }
				/* sԍNA(̏I+1̂-1Zbg) */
				IncLine[IncLevel] = -1;
				/* CN[hLEVELXV */
				IncLevel++;
				rc = NORM;
			}
			else rc = ILLOPR;
			break;
		case OP_LIST:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			ListFlag = 0;
			break;
		case OP_NOLIST:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			/* Xgo͋֎~ */
			ListFlag = 1;
			break;
		case OP_EJECT:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			/* XgLineFeed}vZbg */
			LineFeed = 1;
			break;
		case OP_INCBIN:
			/* IyhGg */
			if ( !OutTbl.opr[1] ){ rc = ILLOPR; break; }
			if ( (len = strlen(OutTbl.opr[1])) < 3 ){ rc = INCNOFILE; break; }
			/* 擪эŏI͊ʂł */
			if ( ( OutTbl.opr[1][0] == '(' ) && ( OutTbl.opr[1][len-1] == ')' ) ){
				/* oCit@Co */
				memset( BinFile , 0 , sizeof(BinFile) );
				memcpy( BinFile , &OutTbl.opr[1][1] , len-2 );
				/* oCit@Cǂݏo */
				rc = IncludeBin( &OutTbl.byte , BinFile );
				/* AhXXV */
				AsmAdr += OutTbl.byte;
			}
			else rc = ILLOPR;
			break;
		case OP_AI:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			InstMode = 0;
			break;
		case OP_KC:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			InstMode = 1;
			break;
#if __EUR_MNEMONIC
		case OP_EU:
			/* IyhGg */
			if ( OutTbl.opr[1] ) rc = ILLOPR;
			InstMode = 2;
			break;
#endif /* __EUR_MNEMONIC */
		default:
			/* ʖߏ */
			/* jjbN͐ */
			if ( strlen( OutTbl.opr[0] ) >= MAXMN ) { rc = UNDEFOPR ; break; }
			/* ORGȂ */
			if ( !StartAdrFlag ) { rc = NOORG; break; }
			/* 5Iyhȍ~ɓo^ꍇAG[I */
			if ( OutTbl.opr[5] ){
				rc = ILLOPR;
				break;
			}
			/* Iyh1`5͂ */
			for ( i = 1 ; i < 5 ; i++ ){
				kc = 0;
				/* Iyho^ȂȂ烋[v𔲂 */
				if (!OutTbl.opr[i]) break;
				/* QIyhȍ~ȂA擪J} */
				if ( ( i >= 2 ) && *OutTbl.opr[i] &&( *OutTbl.opr[i] != ',' ) ){
					/* KCł͖[(]ȊOł */
					if( !OutTbl.kc || *OutTbl.opr[i] != '(' ){
						rc = ILLCANMA;
						break;
					}
					kc = 1;
				}
				/* Iyhʎ擾 */
				if ( rc = GetOprKind( i, OutTbl.opr[i]+( (i==1)||kc ? 0 : 1 ) , &op , &opdat ,&si ) ){
					if ( rc == NOENT ) rc = 0;
					break;
				}
				/* AhX^l ȂG[I(QpX) */
				if ( pass && (( op & LBLMASK ) == LBLNG ) ){
					rc = LBLNOENT;
					break;
				}
				/* OPR2łACfbNXw肠 */
				if ( ( i == 2 ) && si ){
					/* OPR1́A$31A$30A$0wł */
					switch ( OutTbl.opkind[0] ){
					case RSX:
					case RSY:
					case RSZ:
						/* ʏ탌WX^wɕύX */
						OutTbl.opkind[0] = REG;
						break;
					case MRSX:
					case MRSY:
					case MRSZ:
						/* ʏ탌WX^wɕύX */
						OutTbl.opkind[0] = MREG;
						break;
					default:
						break;
					}
				}
				/* CfbNXwtOZbg */
				if ( !OutTbl.si && si ){
					OutTbl.si = si;
				}
				/* Iyhʁ^f[^ۑ */
				OutTbl.opkind[i-1] = op;
				OutTbl.opdata[i-1] = opdat;
#if __DEBUG
				printf("kind=%x data=%x\n",op,opdat);
#endif
			}
			/* Iyhʃ`FbNɂăG[ */
			if (rc) break;
			/* CfbNXw肠 */
			if( OutTbl.si ){
				/* jjbN{P`SIyhŌ(OP1/OP2ƂR0,R30,R31L) */
				rc = SearchOpr( MASKOP2 , MASKOP2 , MASKOP , MASKOP );
				break;
			}
			/* ZJhIy[VgIvViCASIOJjI */
			if( UndefOpr ){
				/* jjbN{P`SIyhŌ(OP1/OP2ƂR0,R30,R31L) */
				if (!(rc=SearchOpr( MASKOP2 , MASKOP2 , MASKOP , MASKOP ))) break;
				/* jjbN{P`SIyhŌ(OP2̂R0,R30,R31L) */
				if (!(rc=SearchOpr( MASKOP , MASKOP2 , MASKOP , MASKOP ))) break;
				/* jjbN{P`SIyhŌ(OP1̂R0,R30,R31L) */
				if (!(rc=SearchOpr( MASKOP2 , MASKOP , MASKOP , MASKOP ))) break;
			}
			/* jjbN{P`RIyh ɂČ(R0,R30,R31wȂ) */
			rc = SearchOpr( MASKOP , MASKOP , MASKOP , MASKOP );
			break;
		}
	}
	return rc;
}

/**********************************************************************/
/*   SearchOpr : Search Operation Code                                */
/*                                                                    */
/*       : w肳ꂽIyhOutBuf̖߂       */
/*             ʂ́AOutBufɊi[                         */
/*       : Iyh(op1,op2,op3,op4)                    */
/*   o    : G[i0:Y߂A0ȊO:Ȃj               */
/*                                                                    */
/**********************************************************************/
int SearchOpr( unsigned short op1 ,unsigned short op2 ,unsigned short op3 ,unsigned short op4 )
{
unsigned short i;
int def_opr = 0;
#if __DEBUG
	printf("opr = %s\n",oprwk);
#endif
	/* ΏۃjjbNHD61`ɕϊ */
	if ( ChgKcName( oprwk , OutTbl.opr[0] ) ) return UNDEFOPR;
#if __EUR_MNEMONIC
	/* #EU /EUwL */
	if ( InstMode == 2 ){
		/* EU(Europe)`jjbNHD61`ɂ */
		if ( ChgEuropeName( oprwk , OutTbl.opr[0] ) ) return UNDEFOPR;
	}
#endif /* __EUR_MNEMONIC */
	/* jjbN{P`RIyh ɂČ */
	for ( i = 0 ; i < MAXOP ; i++ ){
		/* Y߂ */
		if ( !strcmp( codetbl[i].name , oprwk ) ){
			/* jjbN͈v */
			def_opr = 1;
			/* Iyhʂv */
			if ( ((codetbl[i].op1&MASKOP2) == (OutTbl.opkind[0]&op1) )
				&& ((codetbl[i].op2&MASKOP2) == (OutTbl.opkind[1]&op2) )
				&& ((codetbl[i].op3&MASKOP)  == (OutTbl.opkind[2]&op3) )
				&& ((codetbl[i].op4&MASKOP)  == (OutTbl.opkind[3]&op4) )){
				/* R[he[ũCfbNXi[ */
				OutTbl.idx = i;
				OutTbl.byte = codetbl[i].byte;
				/* AZuAhXXV */
				if (( AsmAdr + codetbl[i].byte ) <= MAXOBJ ){
					AsmAdr += codetbl[i].byte;
					return NORM;
				}
				else return ADOFLOW;
			}
		}
	}
	/* Iyhʕsv/Y߂Ȃ */
	return ( def_opr ? ILLOPR : UNDEFOPR );
}
/**********************************************************************/
/*   AsmCodeSet : Assembler Process ( 2 pass )                        */
/*                                                                    */
/*       : Ps̃AZuʂR[hiQpX)        */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int AsmCodeSet( void )
{
int  rc,n;
unsigned short op,opdat,sts,adr;

	/* G[Xe[^X */
	rc = 0;

	/* AZuAhXXV */
	adr = OutTbl.adr;

	/******************************************/
	/* #if`#else`#endif}N           */
	/******************************************/
	/* jjbNo^ */
	if ( OutTbl.opr[0] ){
		/* #if,#else,#endif`FbN */
		ChgCode( oprwk , OutTbl.opr[0] );
		sts = (unsigned short)GetMacKind( oprwk );
		switch( sts ){
		case OP_IF:
		case OP_ELSE:
		case OP_ENDIF:
			return NORM;
		default:
			break;
		}
	}
	/******************************************/
	/* ^/ʖߏ                  */
	/******************************************/
	/* jjbNo^ */
	if ( OutTbl.opr[0] ){
		/* ʏ햽߁^^ߎʃ`FbN */
		switch( OutTbl.kind ){
		case OP_ORG:
		case OP_EQU:
		case OP_DS:
		case OP_DB:
		case OP_DW:
		case OP_INCLUDE:
		case OP_LIST:
		case OP_NOLIST:
		case OP_EJECT:
		case OP_INCBIN:
			break;
		case OP_START:
			/* START */
			/* sJnAhX擪AhX菬ꍇ̓G[I */
			if ( ExecAdrFlag && ( StartAdr > ExecAdr ) ) return EOFLOW;
			break;
		default:
			/* ʖߓo^ */
			if ( OutTbl.byte ){
				/* JRߗpIyhԍ */
				n = 1;
				/* ߃R[ho */
				OutTbl.code[0] = codetbl[OutTbl.idx].code;
				/* ߎʂɂĕ */
				switch( codetbl[OutTbl.idx].kind ){
				case NU:	/* IyhȂ^1 byte   */
					break;
				case IM8_NU:/* IM8        (QoCg߁j   */
					/* Iyh`FbN */
					if (OutTbl.opdata[1] >= IM8bit ){ rc = OFLOW ; break; }
				case REG_NU:/* REG        (QoCg߁j   */
				case REG_NUJ:/* REG : IM7    (3oCg߁j   */
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[0];
					/* Jumpg */
					if ( codetbl[OutTbl.idx].kind == REG_NUJ ){
						/* ΃WvAhXvZ */
						if(rc = GetJumpData( OutTbl.opdata[1] , adr ,OutTbl.byte ,&op , &opdat )) break;
						OutTbl.code[2] = (unsigned char)( op | opdat );
#if __WORD_ADDRESS
						/* IyhR[ho */
						if (Wadr){
							OutTbl.code[2] = 0;
							OutTbl.code[3] = (unsigned char)( op | opdat );
						}
#endif
					}
					break;
				case IR_REG:/* IREGFREG  (QoCg)        */
				case IR_REGJ:/* IREGFREG :IM7 (3oCg)     */
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[1];
					/* Jumpg */
					if ( codetbl[OutTbl.idx].kind == IR_REGJ ){
						/* ΃WvAhXvZ */
						if(rc = GetJumpData( OutTbl.opdata[2] , adr ,OutTbl.byte ,&op , &opdat )) break;
						OutTbl.code[2] = (unsigned char)( op | opdat );
#if __WORD_ADDRESS
						/* IyhR[ho */
						if (Wadr){
							OutTbl.code[2] = 0;
							OutTbl.code[3] = (unsigned char)( op | opdat );
						}
#endif
					}
					break;
				case IR_IM5:/* IREGFIM5  (QoCg)        */
					/* Iyh`FbN */
					if (OutTbl.opdata[1] >= IM5bit ){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[1];
					break;
				case IR_IM8:/* IREGFIM8  (RoCg)        */
					/* Iyh`FbN */
					if (OutTbl.opdata[1] >= IM8bit ){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop;
					OutTbl.code[2] = (unsigned char)OutTbl.opdata[1];
					break;
				case IR_RIM3:/* IREG: REG: IM3  (RoCg)        */
					/* Iyh`FbN */
					if ((OutTbl.opdata[2] <= 1 )||(OutTbl.opdata[2] > IM3bit )){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop|(unsigned char)OutTbl.opdata[1];
					OutTbl.code[2] = (unsigned char)((OutTbl.opdata[2]-1)<<5);
					break;
				case REG_IM3:/* REG : IM3  (RoCg)        */
					/* Iyh`FbN */
					if ((OutTbl.opdata[1] <= 1 )||(OutTbl.opdata[1] > IM3bit )){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop|(unsigned char)OutTbl.opdata[0];
					OutTbl.code[2] = (unsigned char)((OutTbl.opdata[1]-1)<<5);
					break;
				case REG_I5I3:/* REG : IM5 : IM3  (RoCg)     */
				case REG_I5I3J:/* REG : IM5 : IM3 : IM7 (4oCg) */
					/* Iyh`FbN */
					if ( OutTbl.opdata[1] > 31 ){ rc = OFLOW ; break; }
				case REG2_IM3:/* REG : REG : IM3  (RoCg)     */
				case REG2_IM3J:/* REG : REG : IM3 : IM7 (4oCg) */
					/* Iyh`FbN */
					if ((OutTbl.opdata[2] <= 1 )||(OutTbl.opdata[2] > IM3bit )){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[0];
					/* IyhR[ho */
					if (( codetbl[OutTbl.idx].kind == REG2_IM3 )||( codetbl[OutTbl.idx].kind == REG2_IM3J ) ){
						opdat = (!OutTbl.opdata[1]||(OutTbl.opdata[1]==31)||(OutTbl.opdata[1]==30)) ? (unsigned short)0 : OutTbl.opdata[1];
						OutTbl.code[2] = (unsigned char)opdat|(unsigned char)((OutTbl.opdata[2]-1)<<5);
					}
					else{
						/* IyhR[ho */
						OutTbl.code[2] = (unsigned char)OutTbl.opdata[1]|(unsigned char)((OutTbl.opdata[2]-1)<<5);
					}
					/* Jumpg */
					if (( codetbl[OutTbl.idx].kind == REG2_IM3J )||( codetbl[OutTbl.idx].kind == REG_I5I3J )){
						/* ΃WvAhXvZ */
						if(rc = GetJumpData( OutTbl.opdata[3] , adr ,OutTbl.byte ,&op , &opdat )) break;
						/* IyhR[ho */
						OutTbl.code[3] = (unsigned char)( op | opdat );
					}
					break;
				case REG_IM7:/* REG FIM7  (RoCg)        */
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[0];
					/* ΃WvAhXvZ */
					if(rc = GetJumpData( OutTbl.opdata[2] , adr ,OutTbl.byte ,&op , &opdat )) break;
					/* IyhR[ho */
					OutTbl.code[2] = (unsigned char)( op | opdat );
#if __WORD_ADDRESS
					if (Wadr){
						OutTbl.code[2] = 0;
						OutTbl.code[3] = (unsigned char)( op | opdat );
					}
#endif
					break;
				case REG2_IM7:	/* REG : REG FIM7  (SoCg)        */
								/* REG : IM8 FIM7  (SoCg)        */
					/* Iyh`FbN */
					if (OutTbl.opdata[1] >= IM8bit ){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[0];
					OutTbl.code[2] = (unsigned char)OutTbl.opdata[1];
					/* ΃WvAhXvZ */
					if(rc = GetJumpData( OutTbl.opdata[2] , adr ,OutTbl.byte ,&op , &opdat )) break;
					/* IyhR[ho */
					OutTbl.code[3] = (unsigned char)( op | opdat );
					break;
				case REG_REG:/* REG FREG  (RoCg)        */
				case REG_IM8:/* REG FIM8  (RoCg)        */
					/* Iyh`FbN */
					if (OutTbl.opdata[1] >= IM8bit ){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[0];
					OutTbl.code[2] = OutTbl.opdata[1];
					break;
				case NU_IM8:/* NU FIM8  (RoCg)        */
					/* Iyh`FbN */
					if (OutTbl.opdata[0] >= IM8bit ){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop;
					OutTbl.code[2] = OutTbl.opdata[0];
					break;
				case IM8_REG:/* IM8 FREG  (RoCg)        */
				case MREG_REG:/* MREG FREG  (RoCg)        */
					/* Iyh`FbN */
					if (OutTbl.opdata[0] >= IM8bit ){ rc = OFLOW ; break; }
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[1];
					OutTbl.code[2] = OutTbl.opdata[0];
					break;
				case IM16_REG:/* IM16 : REG (SoCg) IyR[h0xD0       */
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop;
					OutTbl.code[2] = (unsigned char)( OutTbl.opdata[0] & 0xff );
					OutTbl.code[3] = (unsigned char)( OutTbl.opdata[0] >> 8 );
					break;
				case REG_IM16:/* REG FIM16 (SoCg) IyR[h0xD1       */
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)OutTbl.opdata[0];
					OutTbl.code[2] = (unsigned char)( OutTbl.opdata[1] & 0xff );
					OutTbl.code[3] = (unsigned char)( OutTbl.opdata[1] >> 8 );
					break;
				case IR_IM16:/* IREG FIM16 (SoCg)        */
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop;
					OutTbl.code[2] = (unsigned char)( OutTbl.opdata[1] & 0xff );
					OutTbl.code[3] = (unsigned char)( OutTbl.opdata[1] >> 8 );
					break;
				case IM7_NU:/* l(7bit):Ȃ JR       */
					n = 0;
				case F_IM7:	/* tO:l(7bit) JR     */
					if ( OutTbl.pm7 ){
						if ( OutTbl.opdata[n] >= 128 ) { rc = JOFLOW ; break; }
						/* ΃WvAhXݒ(}IM7`) */
						op = (unsigned short)(( OutTbl.pm7 == 2 ) ? 0x80 : 0 );
						opdat = OutTbl.opdata[n];
					}
					/* ΃WvAhXvZ */
					else if(rc = GetJumpData( OutTbl.opdata[n] , adr ,OutTbl.byte ,&op , &opdat )) break;
					/* IyhR[ho */
					OutTbl.code[1] = (unsigned char)( op | opdat );
					break;
				/* tO:l(16bit)JP/CAL */
				case F_IM16:
					/* IyhR[ho */
					OutTbl.code[1] = (unsigned char)( OutTbl.opdata[1] & 0xff );
					OutTbl.code[2] = (unsigned char)( OutTbl.opdata[1] >> 8 );
#if __WORD_ADDRESS
					if (Wadr){
						OutTbl.code[2] = 0;
						OutTbl.code[3] = (unsigned char)( OutTbl.opdata[1] >> 8 );
					}
#endif
					break;
				/* l(16bit):Ȃ JP/CAL  */
				case IM16_NU:
					/* IyhR[ho */
					OutTbl.code[1] = codetbl[OutTbl.idx].secop |(unsigned char)( OutTbl.opdata[0] & 0xff );
					OutTbl.code[2] = (unsigned char)( OutTbl.opdata[0] >> 8 );
#if __WORD_ADDRESS
					if (Wadr){
						OutTbl.code[2] = 0;
						OutTbl.code[3] = (unsigned char)( OutTbl.opdata[0] >> 8 );
					}
#endif
					break;
				default:
					rc = UNDEFOPR;
					break;
				}
			}
			break;
		}
	}

	return rc;
}
/**********************************************************************/
/*   GetJumpData : Get Jump Address data                              */
/*                                                                    */
/*       : ΃Wvlf[^擾                       */
/*       : |C^Af[^|C^                         */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetJumpData( unsigned short jadr , unsigned short adr  , unsigned short byte ,unsigned short *op ,unsigned short *opdat )
{
#if __WORD_ADDRESS
	if (Wadr) byte /= 2;
#endif
	/* ΃WvAhXvZ */
	if ( jadr > adr ){
		/* {Wv */
		*opdat = jadr - ( adr + ( byte - 1 ));
		*op = 0;
	}
	else{
		/* |Wv */
		*opdat = ( adr + ( byte - 1 ) ) - jadr;
		*op = 0x80;
	}
	/* WvAhXI[o[ */
	if ( *opdat >= IM7bit ) return JOFLOW;

	return NORM;
}
/**********************************************************************/
/*   GetLine : Get Source Line                                        */
/*                                                                    */
/*       : \[Xt@CPs̕擾             */
/*       : \[Xt@C                                       */
/*       : ̓t@ChcAo̓obt@|C^                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetLine( FILE *fd ,char *buff )
{
int	sts;
int	i;
	/* 1sI܂Ŏo */
	for( i = 0 ; i < MAXLINE ; i++ ){
		/* 1o */
		sts = fgetc( fd );
		switch ( sts ){
		case '\r':
			break;
		/* PsI */
		case '\n':
			return NORM;
		/* t@CI */
		case 0x1a:
		case EOF:
			return EOFERR;
		default:
			*buff++ = ( char )sts;
			break;
		}
	}
	return LOFLOW;
}

/**********************************************************************/
/*   GetParam : Get Parameter String                                  */
/*                                                                    */
/*       : ep[^擾                           */
/*       : sobt@|C^                                     */
/*   o    : G[i0:A0ȊO:YȂj             */
/*                                                                    */
/**********************************************************************/
/* 
 F^ꂽ[Nobt@̕p[^ɕOutTblɓo^B
       Tv͈ȉ̒ʂB
      (1)s擪ɂ^u^Xy[X͍폜B
      (2)ŏ̕ɃR[:]oƃxƂĊi[B
      (3)jjbNo^[&][$][(]^uXy[XoƉsăIyhƂĊi[B
      (4)̐擪ȊOɃJ}[,]oƉsiCfbNXXVjB
      (5)擪́Aʓ[( ` )]ɋLqꂽ^u^Xy[X͋l߂Ċi[B
       i^u^Xy[X͊{IɊi[Ȃj
        A3Iyhȍ~AJR^OoꍇͤXy[X1}B
      (6)_uR[e[V["]oƁA["]oꂷ邩s܂ł̂܂܊i[B
      (7)Z~R[;]oƁAȍ~As܂łRgƂēo^B
        _uR[e[V͂̂܂ܓo^B
      (8)KCΉŁA擪ȊO̊[(]oɑO̕[!+-*^|^%,($]ȊȌꍇA
         sB̎AKCtOONɂB(jjbNϊ̑Ó`FbNׁj
      (9)VOR[e[V[']oƁA[']oꂷ邩s܂ł̂܂܊i[B
         _uR[e[VƂ͔r삷B
*/
int GetParam( char *buff )
{
int	len;
int	j,n;
int label;
int kakko;
int dq,sq;
char *Opr;
	/* Iyhobt@|C^ */
	OutTbl.opr[0] = OutTbl.line;
	Opr = OutTbl.line;

	/* 1sI܂Ŏo */
	len = strlen( buff );
	for(  j = 0 , n = 0 ,label = 0,kakko = 0 ,dq = 0,sq = 0 ; ( n < MAXOPR )&&( j <len ) ; buff++ ){
		switch ( *buff & 0xff ){
		case ';':
			/* Rgo */
			/* R[eV */
			if ( dq || sq ){
				/* p[^o^ */
				Opr[j++] = *buff;
				break;
			}
			/* Rg|C^ݒ */
			OutTbl.comment = Opr+j+1;
			/* c̕RgƂĊi[ */
			memcpy( OutTbl.comment , buff , strlen(buff));
			/* GĝȂIyh|C^NULLɂ */
			if (!j)	OutTbl.opr[n] = 0;
			return NORM;
		case '\n':
		case 0x0:
			/* soŏI */
			/* ʂуR[e[VȂG[ */
			if ( kakko || dq || sq ){
				return ILLDQUO;
			}
			/* GĝȂIyh|C^NULLɂ */
			if (!j) OutTbl.opr[n] = 0;
			return NORM;
		case ':':
			/* R[eV/ʓ */
			if ( dq || sq || kakko ){
				/* p[^o^ */
				Opr[j++]=*buff;
				break;
			}
			/* xo */
			if ( !label && !n ){
				/* xo^ */
				if ( j > MAXNAME ) return LBOFLOW;
				OutTbl.label = Opr;
				/* i[obt@|C^XV */
				Opr += j + 1;
				OutTbl.opr[0] = Opr;
				j = 0;
				label++;
				break;
			}
			/* Qdx̓G[I */
			else if (!n) return ILLLBL;
			return ILLOPR;
		case ',':
			/* s̓rŃJ}o */
			if ( !dq && !sq && j ){
				/* s */
				Opr += j + 1;
				OutTbl.opr[++n] = Opr;
				j = 0;
			}
			/* p[^o^ */
			Opr[j++]=*buff;
			break;
		case ')':
			/* p[^o^ */
			Opr[j++]=*buff;
			/* R[eV */
			if ( dq || sq ) break;
			/* Ƃʌo */
			if ( kakko ){
				kakko--;
				break;
			}
			/* G[I */
			else return ILLDQUO;
#if __SJIS_SPACE
		case 0x81:
			/* SpXy[Xł͂Ȃ */
			if ( buff[1] != 0x40 ){
				/* p[^o^ */
				Opr[j++]=*buff;
				break;
			}
			/* R[e[V͓o^ */
			if ( dq||sq ){
				/* p[^o^ */
				Opr[j++]=*buff;
				break;
			}
			/* |C^XV */
			buff++;
			/* 擪ʓȂǂݔ΂ */
			if ( !j ) break;
			/* jjbNo^Ȃ΁As */
			if ( !n ){
				/* s */
				Opr += j + 1;
				OutTbl.opr[++n] = Opr;
				j = 0;
			}
			break;
#endif
		case 0x20:
		case '\t':
			/* QIyhȍ~łAJR^Oł */
			if ( (n >= 2)&&( j == 3 )&&
				( !strcmp( &Opr[0],",jr" )||!strcmp( &Opr[0],",JR" ))){
				/* Xy[XƂēo^ */
				Opr[j++] = 0x20;
				break;
			}
			/* R[e[V͓o^ */
			if ( dq || sq ){
				/* p[^o^ */
				Opr[j++]=*buff;
				break;
			}
			/* 擪ʓȂǂݔ΂ */
			if ( !j ) break;
			/* jjbNo^Ȃ΁As */
			if ( !n ){
				/* s */
				Opr += j + 1;
				OutTbl.opr[++n] = Opr;
				j = 0;
			}
			break;
		/* VOR[e[V}[No */
		case 0x27:
			/* _uR[e[VȂAp[^o^ */
			if ( dq ){
				Opr[j++]=*buff;
				break;
			}
			/* VOR[e[V}[No */
			if ( !sq ){
				sq++;
				/* 擪Iyhł */
				if ( j && !n ){
					/* s */
					Opr += j + 1;
					OutTbl.opr[++n] = Opr;
					j = 0;
				}
				/* p[^o^ */
				Opr[j++]=*buff;
			}
			else{
				sq--;
				/* p[^o^ */
				Opr[j++]=*buff;
			}
			break;
		case 0x22:
			/* VOR[e[VȂAp[^o^ */
			if ( sq ){
				Opr[j++]=*buff;
				break;
			}
			/* _uR[e[V}[No */
			if ( !dq ){
				dq++;
				/* 擪Iyhł */
				if ( j && !n ){
					/* s */
					Opr += j + 1;
					OutTbl.opr[++n] = Opr;
					j = 0;
				}
				/* p[^o^ */
				Opr[j++]=*buff;
			}
			else{
				dq--;
				/* p[^o^ */
				Opr[j++]=*buff;
			}
			break;
		case '(':
			/* ʌo */
			if ( !dq && !sq ) kakko++;
			/* PO̕ZqуJ}ȊO̎As(KCΉ) */
			if ( n && j && !dq && !sq ){
				if ( !strchr( "!+-*/#|^%=<>,($&" , Opr[j-1] ) ){
					/* KCtOZbg */
					OutTbl.kc = 1;
					Opr += j + 1;
					OutTbl.opr[++n] = Opr;
					j = 0;
				}
			}
		case '+':
		case '-':
		case '&':
		case '$':
			/* ̕擪IyhŌoꂽꍇAs */
			if ( !n && !dq && !sq && j){
				Opr += j + 1;
				OutTbl.opr[++n] = Opr;
				j = 0;
			}
		default:
			/* LȊȌꍇAp[^o^ */
			Opr[j++]=*buff;
			break;
		}
		/* őIyhzꍇAI */
		if ( j >= MAXLEN ) return OPOFLOW;
	}
	/* ʂуR[e[VȂG[ */
	if ( kakko || dq || sq ) return ILLDQUO;

	/* I */
	return NORM;
}

/**********************************************************************/
/*   GetOprKind : Get Opecode kind                                    */
/*                                                                    */
/*       : ^ꂽeIyR[hɕ             */
/*       : ̓|C^AIyR[h                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*                                                                    */
/**********************************************************************/
int GetOprKind( int num , char * buff , unsigned short * kind , unsigned short * data , unsigned short *sir )
{
char mnwk[MAXMN];	/* jjbNϊp[N */
int rc;
unsigned short op,sts;
#if __DEBUG
printf("GetOprKind [%s]\n",buff);
#endif
	/* ʏ񏉊 */
	*kind = 0;
	*data = 0;
	*sir = 0;
	/* vGgȂꍇAG[I */
	if ( !buff[0] ) return NOENT;

	/* R[hϊ(NullȂG[I) */
	if(!( ChgCode( oprwk , buff ) ) ) return NOENT;

	/* JR^Oł */
	if( !memcmp(oprwk,"JR ", 3 ) ){
		/* vZƂď */
		rc = GetCalcData( &buff[3] , kind , data );
		return rc;
	}
#if __EUR_MNEMONIC
	else if( !memcmp(oprwk,"J.", 2 ) ){
		/* vZƂď */
		rc = GetCalcData( &buff[2] , kind , data );
		return rc;
	}
#endif /* __EUR_MNEMONIC */
	/* Iyh1̎̂݃`FbN */
	if ( num==1 ){
		/* WX^wł */
		if ( !GetIRegKind( buff , &op ) ){
			*kind = op;
			return NORM;
		}
		/* tOwł */
		if ( !GetFlagKind( buff , &op ) ){
			*kind = op;
			return NORM;
		}
	}
	/* CWX^wł */
	if ( !( rc = GetReg( buff , &sts , sir ) ) ){
		*data = sts;
		/* SIRwȂ */
		if ( !OutTbl.si ){
			switch( sts ){
			case 0:  *kind = RSZ; break;
			case 30: *kind = RSY; break;
			case 31: *kind = RSX; break;
			default: *kind = REG; break;
			}
		}
		/* SIRw肪ꍇAʏ탌WX^wƂ */
		else *kind = REG;
		return NORM;
	}
	/* IyhLqCWX^wȊO */
	if ( rc != ILLOPR ) return rc;
	/* CfbNXwł */
	if ( !( rc = GetIndexKind( buff , &op , &sts , sir ) ) ){
		*data = sts;
		*kind = op;
		return NORM;
	}
	/* IyhLqCfbNXwȊO */
	if ( rc != ILLOPR ) return rc;
	/* JR߂ł */
	ChgCode( mnwk , OutTbl.opr[0] );
	if ( !strcmp( mnwk , "JR" ) ){
		/* }IM7`ł */
		if( (buff[0]=='+')||(buff[0]=='-') ){
			OutTbl.pm7 = 1;
			if (buff[0]=='-')
				OutTbl.pm7 = 2;
			/* |C^XV */
			buff++;
		}
	}
#if __EUR_MNEMONIC
	/* EU(Europe)`jjbNgpł */
	if ( InstMode==2 ){
		/* IyhQRłA擪"L"A2ł */
		if ( ( num==2 || num==3 )&&( buff[0]=='L'||buff[0]=='l' )&&( strlen(buff)==2 ) ){
			/* 2`8͈͓̔ł */
			if ( 2<= (int)(buff[1]-'0') <=8 ){
				*data = (unsigned short)(buff[1]-'0');
				*kind =LBLOK;
				return NORM;
			}
		}
	}
#endif /* __EUR_MNEMONIC */
	/* vZƂď */
	if ( !( rc = GetCalcData( buff , kind , data ) ) ) return NORM;
	return rc;
}

/**********************************************************************/
/*   GetIndexKind : Get Memory Index Kind                             */
/*                                                                    */
/*       : CfbNXʂ擾                       */
/*       : ̓|C^AIyR[h                           */
/*   o    : jjbN(kind/opr)                               */
/*           : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetIndexKind( char * buff , unsigned short * kind , unsigned short * data ,unsigned short *sir )
{
char Indexwk[6];
int	i,len,rc;
unsigned short opr,sts,knd;

	/* CfbNXwł */
	len = strlen( buff );
	memcpy( oprwk , buff , len );
	if ( ( oprwk[0] == '(' )&&( oprwk[len-1] == ')' ) ){
		oprwk[len-1] = 0;
		/* CWX^ɂCfbNXł */
		if ( !( rc = GetReg( &oprwk[1] , &sts ,sir ) ) ){
			*data = sts;
			/* SIRwȂ */
			if ( !OutTbl.si ){
				switch(sts){
				case 0:  *kind = MRSZ; break;
				case 30: *kind = MRSY; break;
				case 31: *kind = MRSX; break;
				default: *kind = MREG; break;
				}
			}
			/* SIRw肪ꍇAʏ탌WX^wƂ */
			else *kind = MREG;
			return NORM;
		}
		/* IyhLqCWX^wȊO */
		if ( rc != ILLOPR ) return rc;
		/* CfbNXʂT[` */
		memcpy( Indexwk , oprwk , 4 );
		Indexwk[4] = 0;
		/* e[uT[` */
		for ( i = 0 ; i < MAXIDX ; i++ ){
			/* IXAIZwł */
			if (!strcmp( Indexwk , moprtbl[i].name )){
				sts = moprtbl[i].code;
				/* CWX^ɂCfbNXł */
				if ( !( rc = GetReg( &oprwk[4] , &opr ,sir ) ) ){
					*data = opr;
					/* SIRwȂ */
					if ( !OutTbl.si ){
						switch(opr){
						case 0:  *kind = sts|(unsigned short)RSZ; break;
						case 30: *kind = sts|(unsigned short)RSY; break;
						case 31: *kind = sts|(unsigned short)RSX; break;
						default: *kind = sts|(unsigned short)REG; break;
						}
					}
					/* SIRw肪ꍇAʏ탌WX^wƂ */
					else{ *kind = sts|(unsigned short)REG; }
					return NORM;
				}
				/* IyhLqCWX^wȊO */
				if ( rc != ILLOPR ) return rc;
				/* vZƂď */
				if ( !( rc = GetCalcData( &oprwk[4] , &knd , &opr ) ) ){
					/* ͈͊O̒lł */
					if ( opr > 255 ) return OFLOW;
					*data = opr;
					*kind = sts|knd;
					return NORM;
				}
				return rc;
			}
		}
	}
	/* YȂ */
	return ILLOPR;
}
/**********************************************************************/
/*   GetIRegKind : Get Internal Register Kind                         */
/*                                                                    */
/*       : WX^ʂ擾                             */
/*       : ̓|C^AIyR[h                           */
/*   o    : jjbN(kind)                                   */
/*           : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetIRegKind( char * buff , unsigned short * kind )
{
int	i;
char mnwk[MAXMN];	/* jjbNϊp[N */
	i = 0;
	/* jjbNʃ`FbN */
	ChgCode( mnwk , OutTbl.opr[0] );
#if __EUR_MNEMONIC
	/* EU(Europe)`jjbNgpł */
	if ( InstMode==2 ){
		/* WX^p߃e[uT[` */
		while( strcmp( mnwk , irtblC[i].name ) ){
			/* Y߂ł͖ꍇAI */
			if ( ++i >= MAXIR ) return ILLOPR;
		}
	}
	else
#endif /* __EUR_MNEMONIC */
	{
		/* WX^p߃e[uT[` */
		while( strcmp( mnwk , irtbl[i].name ) ){
			/* Y߂ł͖ꍇAI */
			if ( ++i >= MAXIR ) return ILLOPR;
		}
	}
	/* Iyh͐ł */
	if ( !strlen(buff) || strlen(buff)>MAXMN ) return ILLOPR;
	/* 啶ɕϊ */
	ChgCode( mnwk , buff );
#if __EUR_MNEMONIC
	/* EU(Europe)`jjbNgpł */
	if ( InstMode==2 ){
		/* WX^e[u(EU(Europe)pǉ)T[` */
		for ( i=0 ; i < MAXIREG+IREGADD ; i++ ){
			if (!strcmp( mnwk , regtbl[i].name )){
				/* WX^R[hԂ */
				*kind = regtbl[i].code;
				return NORM;
			}
		}
	}
	else
#endif /* __EUR_MNEMONIC */
	{
		/* WX^e[uT[` */
		for ( i = 0 ; i < MAXIREG ; i++ ){
			if (!strcmp( mnwk , regtbl[i].name )){
				/* WX^R[hԂ */
				*kind = regtbl[i].code;
				return NORM;
			}
		}
	}
	/* YȂԂ */
	return ILLOPR;
}
/**********************************************************************/
/*   GetFlagKind : Get Flag Register Kind                             */
/*                                                                    */
/*       : tOʂ擾                               */
/*       : ̓|C^AIyR[h                           */
/*   o    : jjbN(kind)                                   */
/*           : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetFlagKind( char * buff , unsigned short * kind )
{
int	i;
char mnwk[MAXMN];	/* jjbNϊp[N */
	i = 0;
	/* jjbNʃ`FbN */
	ChgCode( mnwk , OutTbl.opr[0] );
	/* tOp߃e[uT[` */
	while( strcmp( mnwk , fltbl[i].name ) ){
		/* Y߂ł͖ꍇAI */
		if ( ++i >= MAXFL ) return ILLOPR;
	}
	/* Iyh͐ł */
	if ( !strlen(buff) || strlen(buff) > MAXMN ) return ILLOPR;
	/* 啶ɕϊ */
	ChgCode( mnwk , buff );
	/* tOe[uT[` */
	for ( i = 0 ; i < MAXFLAG ; i++ ){
		if (!strcmp( mnwk , flagtbl[i].name )){
			/* tOR[hԂ */
			*kind = flagtbl[i].code;
			return NORM;
		}
	}
	/* YȂԂ */
	return ILLOPR;
}
/**********************************************************************/
/*   GetReg : Get Register Number                                     */
/*                                                                    */
/*       : ^ꂽ񂩂烌WX^ԍ擾             */
/*       : ̓|C^AIyR[h                           */
/*   o    : WX^ԍ(data)                                     */
/*           : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetReg( char * buff , unsigned short * data ,unsigned short * sir )
{
char mnwk[MAXMN];	/* jjbNϊp[N */
unsigned short sts,kind;
int rc;
	/* SIRwtONA */
	*sir = 0;
#if __EUR_MNEMONIC
	/* EU(Europe)`jjbNgpł */
	if ( InstMode==2 ){
		/* WX^wł */
		if ( buff[0] == '#' ){
			/* CfbNXw`FbN */
			if ( strlen(buff) < MAXMN ){
				ChgCode( mnwk , &buff[0] );
				/* #0wł */
				if ( !strcmp( mnwk ,"#0" ) ){
					*data = 31;
					*sir = 1;
					return ( OutTbl.si ? REGERR : NORM );
				}
				/* #1wł */
				if ( !strcmp( mnwk ,"#1" ) ){
					*data = 30;
					*sir = 1;
					return ( OutTbl.si ? REGERR : NORM );
				}
				/* #2wł */
				if ( !strcmp( mnwk ,"#2" ) ){
					*data =  0;
					*sir = 1;
					return ( OutTbl.si ? REGERR : NORM );
				}
			}
			/* #0,#1,#2ȊOȂAG[Ƃ */
			*data = 0;
			return REGERR;
		}
	}
#endif /* __EUR_MNEMONIC */
	/* WX^w($0`$31)ł */
	if ( buff[0] == '$' ){
		/* CfbNXw`FbN */
		if ( strlen(buff) < MAXMN ){
			ChgCode( mnwk , &buff[1] );
			/* $SXwł */
			if ( !strcmp( mnwk ,"(SX)" ) || !strcmp( mnwk ,"SX" )
				){
				*data = 31;
				*sir = 1;
				return ( OutTbl.si ? REGERR : NORM );
			}
			/* $SYwł */
			if ( !strcmp( mnwk ,"(SY)" ) || !strcmp( mnwk ,"SY" )
				){
				*data = 30;
				*sir = 1;
				return ( OutTbl.si ? REGERR : NORM );
			}
			/* $SZwł */
			if ( !strcmp( mnwk ,"(SZ)" ) || !strcmp( mnwk ,"SZ" )
				){
				*data =  0;
				*sir = 1;
				return ( OutTbl.si ? REGERR : NORM );
			}
		}
		/* WX^ԍ擾 */
		if(!(rc = GetCalcData( &buff[1] , &kind , &sts ) )){
			/* ̖̏ꍇAG[I */
			if ( kind == LBLNG ) return LBLNOENT;
			/* WX^ԍ */
			if ( sts <= 31 ){
				*data = sts;
				return NORM;
			}
			/* G[I */
			*data = 0;
			return REGERR;
		}
		else return rc;
	}

	/* G[I */
	*data = 0;
	/* WX^wł͂Ȃ */
	return ILLOPR;
}
/**********************************************************************/
/*   SetLabelTbl : Entry Label table                                  */
/*                                                                    */
/*       : xe[uɃxƃAhXo^             */
/*       : x|C^Ao^AhXli0:ȊOj               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int SetLabelTbl( char * buff , unsigned short adr ,unsigned char flag )
{
LBL * Label;
LBL * Labelwk;

	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if (!strcmp( Label->name , buff )){
			/* ɓ̂gĂꍇAG[I */
			return DUPLBL;
		}
		/* ŏIxAhXB */
		if ( !Label->np ) break;
		/* x|C^XV */
		Label = Label->np;
	}
	/* xe[um */
	if ( Labelwk = malloc( sizeof(LBL)+strlen(buff) ) ){
		memset( Labelwk , 0 , sizeof(LBL)+strlen(buff) );
	}
	else return LBNOALOC;

	/* o^Ȃ擪|C^ɓo^ */
	if ( !LabelTbl ) LabelTbl = Labelwk;
	/* mۂ|C^|C^Ƃēo^ */
	else Label->np = Labelwk;

	/* x|C^XV */
	Label = Labelwk;
	/* x̂e[uɓo^ */
	memcpy( Label->name , buff , strlen(buff) );
	/* ݂̃AZuAhXxe[uɓo^ */
	Label->adr = adr;
	/* xʂo^ */
	Label->flag = flag;
	/* xo^XV */
	LabelCnt++;

	return NORM;
}

/**********************************************************************/
/*   GetLabelAdr : Get Label Address                                  */
/*                                                                    */
/*       : xAhX                         */
/*       : x|C^Ao^AhXl                         */
/*   o    : G[i0:A0ȊO:xGgȂj       */
/*                                                                    */
/**********************************************************************/
int GetLabelAdr( char * buff , unsigned short * adr )
{
LBL * Label;
	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if (!strcmp( Label->name , buff )){
			/* ORG߂ŗpipjĂH */
			if( OutTbl.kind == OP_ORG ){
				/* AhXxʂɐUւ */
				Label->flag = LBL_ADR;
			}
			/* xAhX/ʂԂ */
			*adr = Label->adr;
			LblFlg |= Label->flag;
			return NORM;
		}
		/* x|C^XV */
		Label = Label->np;
	}
	return LBLNOENT;
}

/**********************************************************************/
/*   GetMacKind : Get Macro Kind                                      */
/*                                                                    */
/*       : }Nʂ肷                                   */
/*       : Iyh|C^                                     */
/*   o    : jjbN                                         */
/*                                                                    */
/**********************************************************************/
int GetMacKind( char * buff )
{
int	i;
	/* ^߃e[uT[` */
	for ( i = 0 ; i < MACDIR ; i++ ){
		if (!strcmp( buff , MacTbl[i].name ))
			/* ^߃R[hԂ */
			return MacTbl[i].code;
	}
	/* YȂiʖ߁jԂ */
	return UNDEFOPR;
}

/**********************************************************************/
/*   GetMnemonicKind : Get Mnemonic Kind                              */
/*                                                                    */
/*       : jjbNʂ肷                               */
/*       : Iyh|C^                                     */
/*   o    : jjbN                                         */
/*                                                                    */
/**********************************************************************/
unsigned short GetMnemonicKind( char * buff )
{
int	i;
	/* ^߃e[uT[` */
	for ( i = 0 ; i < MAXDIR ; i++ ){
		if (!strcmp( buff , Directivetbl[i].name ))
			/* ^߃R[hԂ */
			return Directivetbl[i].code;
	}
	/* YȂiʖ߁jԂ */
	return UNDEFOPR;
}
/**********************************************************************/
/*   CheckLabel : Check Label String                                  */
/*                                                                    */
/*       : x̌S`FbN                     */
/*       : Iyh|C^                                     */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int CheckLabel( char * buff )
{
int	i,len;

	/* x񒷃`FbN */
	len = strlen( buff );
	if( !len  ) return ILLOPR;
	if( len > MAXNAME ) return OPOFLOW;
	/* 擪ł͂Ȃ */
	if( strchr( DecStr , buff[0] ) ) return ILLLBL;
	/* xps */
	for( i = 0 ; i < len ; i++ ){
		/* x`FbN */
		if( !strchr( LabelStr , buff[i] ) ) return ILLLBL;
	}
	/* I */
	return NORM;
}
/**********************************************************************/
/*   ChgCode : Change String code  (abc...->ABC...)                   */
/*                                                                    */
/*       : At@xbg啶ɕϊ                 */
/*       : Iyh|C^Ao̓obt@|C^               */
/*   o    : ϊ                                           */
/*                                                                    */
/**********************************************************************/
int ChgCode( char * dst , char * src )
{
int	i,len;
	/* o͐敶NA */
	dst[0] = 0;
	if (! src ) return 0;
	/* Iyh񒷃`FbN */
	len = strlen( src );
	if( !len || ( len > MAXLEN ) ) return 0;
	/* ϊ */
	for( i = 0 ; i < len ; i++ ){
		/* `FbN */
		if( (src[i] >= 'a')&&(src[i] <= 'z') ){
			/* At@xbgȂ啶ɕϊ */
			dst[i] = (char)(src[i] - 0x20);
		}
		else{
			/* ̂܂܃Rs[ */
			dst[i] = src[i];
		}
	}
	/* ŏINull} */
	dst[i] = 0;
	return len;
}

/**********************************************************************/
/*   ChgKcName : Change KC Mnemonic Name  (KC->HD61)                  */
/*                                                                    */
/*       : KC`̃jjbNHD61`ɕϊ                 */
/*       : Iyh|C^Ao̓obt@|C^               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ChgKcName( char * dst , char * src )
{
int len;
char mnwk[MAXMN+1];	/* jjbNϊp[N */
	/* [NGA */
	memset( mnwk , 0 , sizeof(mnwk) );
	/* ̓jjbN */
	if (!( len = ChgCode( mnwk , src ) )) return UNDEFOPR;
	/* LDD/STDn񖽗߂ł */
	if ( !memcmp( mnwk , "LDM" , 3 )||!memcmp( mnwk , "STM" , 3 ) ){
		/* 8rbgA16rbg߂ł(3IyhȂ) */
		if(!OutTbl.opr[3]){
			mnwk[2]='D';
			if ( mnwk[3]!='W' ){
				OutTbl.sts = 1;
			}
		}
		/* }`[hvł */
		else{
			/* KC`v */
			if( OutTbl.kc ){
				/* STMWLDMW ł */
				if( mnwk[3] == 'W' ){
					mnwk[2] = 'D';
					mnwk[3] = 'M';
				}
				else return UNDEFOPR;
			}
		}
	}
	else{
		/* KC`v */
		if( OutTbl.kc ){
			/* xxxxW ł */
			if( mnwk[len-1] == 'W' ){
				mnwk[len-1] = 'M';
			}
			else  return UNDEFOPR;
		}
	}
	memcpy( dst , mnwk ,MAXMN );
	return NORM;
}
#if __EUR_MNEMONIC
/**********************************************************************/
/*   ChgEuropeName : Change Europe Style Mnemonic Name  (EUR->HD61)   */
/*                                                                    */
/*       : Europe`̃jjbNHD61`ɕϊ             */
/*       : Iyh|C^Ao̓obt@|C^               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ChgEuropeName( char * dst , char * src )
{
int len;
char mnwk[MAXMN+1];	/* jjbNϊp[N */
	/* [NGA */
	memset( mnwk , 0 , sizeof(mnwk) );
	/* ̓jjbN */
	if (!( len = ChgCode( mnwk , src ) )) return UNDEFOPR;
	/* AI`̃}`[hwȂG[Ƃ */
	if (mnwk[len-1] == 'M') return UNDEFOPR;
	/* OCBn񖽗߂ł */
	if ( !memcmp( mnwk , "OCB" , 3 ) ){
		/* STLnɕύX */
		memcpy( mnwk, "STL" , 3 );
		/* }`[hwł͂Ȃ */
		if (mnwk[3] != 'L'){
			goto ChgEnd;
		}
	}
	/* ICBn񖽗߂ł */
	else if ( !memcmp( mnwk , "ICB" , 3 ) ){
		/* LDLnɕύX */
		memcpy( mnwk, "LDL" , 3 );
		/* }`[hwł͂Ȃ */
		if (mnwk[3] != 'L'){
			goto ChgEnd;
		}
	}
	/* PCBn񖽗߂ł */
	else if ( !memcmp( mnwk , "PCB" , 3 ) ){
		/* LDLnɕύX */
		memcpy( mnwk, "PPO" , 3 );
		/* }`[hwł͂Ȃ */
		if (mnwk[3] != 'L'){
			goto ChgEnd;
		}
	}
	/* PRAn񖽗߂ł */
	else if ( !memcmp( mnwk , "PRA" , 3 ) ){
		/* PSRnɕύX */
		memcpy( mnwk, "PSR" , 3 );
		/* }`[hwł͂Ȃ */
		if (mnwk[len-1] != 'L'){
			goto ChgEnd;
		}
	}
	/* GRAn񖽗߂ł */
	else if ( !memcmp( mnwk , "GRA" , 3 ) ){
		/* GSRnɕύX */
		memcpy( mnwk, "GSR" , 3 );
		/* }`[hwł͂Ȃ */
		if (mnwk[len-1] != 'L'){
			goto ChgEnd;
		}
	}
	/* BDN/BUPn񖽗߂ł */
	else if ( !memcmp( mnwk , "BDN" , 3 ) || !memcmp( mnwk , "BUP" , 3 ) ){
		/* IyhIM8ł */
		if ( (OutTbl.opkind[0] &MASKOP2)==(IM8 &MASKOP2) ){
			/* BDNS/BUPSnɕύX */
			mnwk[3]='S';
			goto ChgEnd;
		}
	}
	/* JPWn񖽗߂ł */
	else if ( !memcmp( mnwk , "JPW" , 3 ) ){
		/* Iyh1Ȃ */
		if( !OutTbl.opr[1] ){
			return ILLOPR;
		}
		/* Iyh1WX^wł */
		if ( OutTbl.opr[1][0]=='$' || (OutTbl.opr[1][0]=='('&& OutTbl.opr[1][1]=='$') ){
			/* JPnɕύX */
			mnwk[2]=0;
			goto ChgEnd;
		}
	}
	/* CAL/PFL/GFLȊOłA}`[hw xxxxL ł */
	if ( memcmp( mnwk , "CAL" , 3 ) && memcmp( mnwk , "PFL" , 3 ) && memcmp( mnwk , "GFL" , 3 ) && mnwk[len-1] == 'L' ){
		/* }`[hwƂ */
		mnwk[len-1] = 'M';
	}
ChgEnd:
	memcpy( dst , mnwk ,MAXMN );
	return NORM;
}
#endif /* __EUR_MNEMONIC */
/**********************************************************************/
/*   GetCalcData : Get Calculate Data                                 */
/*                                                                    */
/*       : Ƃė^ꂽvZ                     */
/*       : 擪|C^Ao^AhXl                     */
/*   o    : G[i0:A0ȊO:G[j                 */
/*           : (kind)  LBLOK(̉ς)LBLNG(̖)      */
/*           : vZl(adr) LBLOK̂ݗLBȊO͕sl          */
/**********************************************************************/
int GetCalcData( char * buff , unsigned short * kind ,unsigned short * adr )
{
int rc;
unsigned short val;

	/* IyhGg */
	if ( !buff ) return ILLOPR;

	/* vZp񂠂 */
	if ( !strlen(buff) ) return ILLOPR;

	/* vZobt@ */
	CalcPtr = 0;
	memset( calcwk , 0 , sizeof(calcwk) );
	/* w肠 */
	if ( (buff[0]=='-') || (buff[0]=='+') )
		sprintf( calcwk , "0%s" , buff );
	else
		sprintf( calcwk , "%s" , buff );

	/* ̉ς݃Zbg */
	Ckind = LBLOK;

	/* vZ */
	if ( rc = CalcVal( &val ) ) return rc;

	/* 2pXڂɖ`x */
	if ( pass && (Ckind==LBLNG) ) return LBLNOENT;

	/* I */
	*adr = val;
	*kind = Ckind;
	return NORM;
}

/**********************************************************************/
/*   CalcVal : Calculate compare Logical                              */
/*                                                                    */
/*       : ^ꂽrZ(D揇ʍŒ)           */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪̒l擾 */
	if( rc = CalcVal0( &val ) ) return rc;
	while( 1 ){
		switch( calcwk[CalcPtr] ){
		/* =  */
		case '=':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '>' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val >= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '<' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val <= wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (unsigned short)(val == wval);
			break;
		/* >  */
		case '>':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '=' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val >= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '<' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val != wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (unsigned short)(val > wval);
			break;
		/* <  */
		case '<':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '=' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val <= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '>' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (unsigned short)(val != wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (unsigned short)(val < wval);
			break;
		case '(':
			return CALERR;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal0 : Calculate Logical                                     */
/*                                                                    */
/*       : ^ꂽ_Z(D揇+1)             */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal0(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪̒l擾 */
	if( rc = CalcValShift( &val ) ) return rc;
	while( 1 ){
		switch( calcwk[CalcPtr] ){
		/* AND */
		case '#':
		case '&':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val &= wval;
			break;
		/* OR */
		case '|':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val |= wval;
			break;
		/* XOR */
		case '^':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val ^= wval;
			break;
		case '(':
			return CALERR;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcValShift : Calculate Shift.                                  */
/*                                                                    */
/*       : ^ꂽVtgZ(D揇+2)           */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcValShift(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪l擾 */
	if( rc = CalcVal1( &val ) ) return rc;
	while( 1 ) {
		/* EVtgZ */
		if ( (calcwk[CalcPtr]=='>')&&(calcwk[CalcPtr+1]=='>') ){
			CalcPtr += 2;
			if ( rc = CalcVal1( &wval ) ) return rc;
			val = val>>wval;
		}
		else if ( (calcwk[CalcPtr]=='<')&&(calcwk[CalcPtr+1]=='<') ){
			CalcPtr += 2;
			if ( rc = CalcVal1( &wval ) ) return rc;
			val = val<<wval;
		}
		else {
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal1 : Calculate Add/Sub.                                    */
/*                                                                    */
/*       : ^ꂽZ(D揇+3)               */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal1(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪l擾 */
	if( rc = CalcVal2( &val ) ) return rc;
	while( 1 ) {
		switch( calcwk[CalcPtr] ){
		/* Z */
		case '+':
			CalcPtr ++;
			if ( rc = CalcVal2( &wval ) ) return rc;
			val += wval;
			break;
		/* Z */
		case '-':
			CalcPtr ++;
			if ( rc = CalcVal2( &wval ) ) return rc;
			val -= wval;
			break;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal2 : Calculate Multiple/Divide.                            */
/*                                                                    */
/*       : ^ꂽ揜Z(D揇+4)               */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal2(unsigned short * value )
{
int rc;
unsigned short val,wval;

	/* 擪l擾 */
	if( rc = CalcVal3( &val ) ) return rc;
	while( 1 ) {
		switch( calcwk[CalcPtr] ){
		/* Z */
		case '*':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			val *= wval;
			break;
		/* Z */
		case '/':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			/* 0ŏZ */
			if ( !wval ) return CALERR;
			val /= wval;
			break;
		/* MOD */
		case '%':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			/* 0ŏZ */
			if ( !wval ) return CALERR;
			val %= wval;
			break;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal3 : Calculate ()                                          */
/*                                                                    */
/*       : ʓ̉Zs(D揇ʍō)                       */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal3( unsigned short *value )
{
int rc;
unsigned short val,flag;

	flag = 0;

	/* ]]v */
	if( calcwk[CalcPtr] == '!' ){
		CalcPtr++;
		flag = 1;
	}
	/* ʓł */
	if( calcwk[CalcPtr] == '(' ) {
		CalcPtr++;
		/* ʓ̌vZ͍łD揇ʂ̒Ⴂɍs */
		if( rc = CalcVal( &val ) ) return rc;
		/* ʂĂȂB*/
		if( calcwk[CalcPtr++] != ')' ) return ILLDQUO;
	}
	else{
		/* l܂̓xł */
		if( rc = GetValue( &val ) ) return rc;
	}
	/* wɂlC */
	if ( calcwk[CalcPtr] == '.'){
		CalcPtr++;
		switch( calcwk[CalcPtr] ){
		/* ʌw */
		case 'u':
		case 'U':
		case 'h':
		case 'H':
			val = (unsigned short)(val >> 8);
			break;
		/* ʌw */
		case 'd':
		case 'D':
		case 'l':
		case 'L':
			val &= 0xff;
			break;
		/* rbg] */
		case 'n':
		case 'N':
			val = (unsigned short)(~val);
			break;
		default:
			return ILLOPR;
		}
		CalcPtr++;
	}
	/* vZlԂ */
	*value = (unsigned short)(!flag ? val : !val);
	return NORM;
}

/**********************************************************************/
/*   GetValue : Get Data Value                                        */
/*                                                                    */
/*       : x܂͐lAlo                     */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : 擾l(value)                                          */
/*           : x̉tO(Ckind) (LBLNG:̖)         */
/*                                                                    */
/**********************************************************************/
int GetValue(unsigned short *value ) {
unsigned short val;
int		i,rc,quo;
char	lblwk[MAXLINE+2];   /* vZl擾px[N   */
char	QuoChar;
	/* f[^ */
	*value = 0;
	/* x/l擾pobt@ */
	memset( lblwk , 0 , sizeof(lblwk) );

	/* Zqo܂ŌJԂ */
	i = 0;
	quo = 0;
	QuoChar = 0;
	while ( 1 ){
		/* 񌟏o */
		if ( !quo ){
			/* R[e[VʁiVO/_u)擾 */
			if ( ( calcwk[CalcPtr] == 0x22 )||( calcwk[CalcPtr] == 0x27 )){
				QuoChar = calcwk[CalcPtr];
				quo ++;
			}
		}
		/* R[e[VH */
		else if ( calcwk[CalcPtr] == QuoChar ) quo ++;
		/* Zq܂NulloɂďI */
		if ( !calcwk[CalcPtr] || (!quo && strchr( "+-*/#|^%().<>=" , calcwk[CalcPtr] )) ) break;
		/* 擪ȊO&oŏI */
		if ( !quo && ( calcwk[CalcPtr] == '&' && i ) ) break;
		/* Rs[ */
		lblwk[i++] = calcwk[CalcPtr++];
		/* R[e[VI */
		if ( quo == 2 ) break;
	}
	/* o͐lł */
	if ( rc = GetData( lblwk , &val ) ){
		/* IyhLqlȊO */
		if (rc != ILLOPR ) return rc;
		/* xł */
		if ( rc = CheckLabel( lblwk ) ) return ILLOPR;
		/* xAhXo */
		if ( GetLabelAdr ( lblwk , &val ) ){
			/* x̖Ƃ */
			Ckind = LBLNG;
			val = 0;
		}
	}
	/* ߂lԂ */
	*value = val;
	return NORM;
}

/**********************************************************************/
/*   GetData : Get Immediate Data                                     */
/*                                                                    */
/*       : 񂩂琔lf[^擾                         */
/*       : |C^Af[^|C^                         */
/*   o    : l(data)                                               */
/*           : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetData( char *buff , unsigned short * data )
{
int	i,len;
unsigned int sts;
	/* Iyh񒷃`FbN */
	len = strlen( buff );
	if( !len  ) return ILLOPR;
	if( len > MAXLEN ) return OPOFLOW;

	/* 擪эŏI̓R[e[V(=Gg)ł */
	if ( (( buff[0] == 0x22 ) && ( buff[len-1] == 0x22 ))
		|| (( buff[0] == 0x27 ) && ( buff[len-1] == 0x27 )) ){
		/* 񒷂RSł */
		if( len == 3 ){
			/* ʂ͎b16rbglƂ */
			*data = (unsigned short)(buff[1]&0xff);
			return NORM;
		}
		else{
			if( len == 4 ){
				/* ʂ͎b16rbglƂ */
				*data = (unsigned short)( (buff[1]&0xff)|((buff[2]&0xff)<<8) );
				return NORM;
			}
			else return ILLOPR;
		}
	}
	/* Qiwł */
	if ( (buff[0] == '&')&&((buff[1] == 'B')||(buff[1] == 'b')) ){
		for( i = 2 , sts = 0; i < len ; i++ ){
			/* 2iグ */
			sts *= 2;
			/* `FbN */
			switch ( buff[i] ){
			case '1':
				sts |= 0x1;
			case '0':
				break;
			default:
				return ILLOPR;
			}
		}
		/* ͈̓I[o[ł */
		if ( sts >= IM16bit ) return OFLOW;
		/* I */
		*data = (unsigned short )sts;
		return NORM;
	}
	/* PUiwł */
	if ( (buff[0] == '&')&&((buff[1] == 'H')||(buff[1] == 'h')) ){
		for( i = 2 ; i < len ; i++ ){
			/* `FbN */
			if( !strchr( HexStr , (int)buff[i] ) ){
			 return ILLOPR;
			 }
		}
		/* PUiɕϊ */
#if __FORDOS
		if ( sscanf( &buff[2] , "%Lx" , &sts ) == EOF ) return ILLOPR;
#else
		if ( sscanf( &buff[2] , "%x" , &sts ) == EOF ) return ILLOPR;
#endif
		/* ͈̓I[o[ł */
		if ( sts >= IM16bit ) return OFLOW;
		/* I */
		*data = (unsigned short)sts;
		return NORM;
	}
	/* POi */
	for( i = 0 ; i < len ; i++ ){
		/* `FbN */
		if( !strchr( DecStr , (int)buff[i] ) ) return ILLOPR;
	}
	/* POiɕϊ */
#if __FORDOS
	if ( sscanf( buff , "%Ld" , &sts ) == EOF ) return ILLOPR;
#else
	if ( sscanf( buff , "%d" , &sts ) == EOF ) return ILLOPR;
#endif
	/* ͈̓I[o[ł */
	if ( sts >= IM16bit ) return OFLOW;

	/* I */
	*data = (unsigned short )sts;
	return NORM;
}

/**********************************************************************/
/*   CheckSetOpt : Check /SET Option Name                             */
/*                                                                    */
/*       : /SETIvV̓o^`FbNs               */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int CheckSetOpt( char * name )
{
int	i;
	/* xo^`FbN */
	for ( i = 0 ; i < SetLabel ; i++ ){
		/* o^xƈv */
		if( !strcmp( SetTbl[i].ent , name ) ) return 0;
	}
	return 2;
}

/**********************************************************************/
/*   CheckSetLbl : Check /SET Option Name                             */
/*                                                                    */
/*       : /SETIvV̓o^`FbNs               */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int CheckSetLbl( char * name ,unsigned short sts )
{
int	i,ent,rc;
	ent = 0;
	/* xo^`FbN */
	for ( i = 0 ; i < SetLabel ; i++ ){
		/* o^xƈv */
		if( !strcmp( SetTbl[i].ent , name ) ){
			ent++;
		}
		/* xƈv */
		if( !strcmp( SetTbl[i].let , name ) ){
			/* xe[uɓo^ */
			if( rc = SetLabelTbl( SetTbl[i].ent , sts ,LBL_EQU ) ) return rc;
		}
	}
	/* o^xƈvꍇAxo^Ԃ */
	if ( ent ) return 1;

	/* YȂ */
	return NORM;
}
/**********************************************************************/
/*   IncludeBin : Include BIN/BMP file                                */
/*                                                                    */
/*       : BinarytH[}bg̃t@COutBufɓǂݏo         */
/*       : obt@ʒm|C^                                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int IncludeBin( unsigned short *cnt ,char *File )
{
int rc,type;
char * fptr;
unsigned int Size = 0;

	/* obt@|C^ */
	type =0;

	/* gqɂt@Cʂ̔ */
	if ((fptr = strrchr( File,  '.' ))){
		ChgCode( oprwk , fptr );
		/* BMPt@Cł */
		if ( !strcmp(".BMP",oprwk ) ){
			type = 1;
		}
	}
	/* oCit@COPEN */
	if ( ( BinFD = fopen( File ,"rb" ) ) <= 0 ){
		printf("Invalid Binary File Name.\n");
		return ILLBIN;
	}

	if (!type){
		/* oCiǂݏo */
		rc = ReadBin( &Size );
	}
	else{
		/* rbg}bvǂݏo */
		rc = ReadBmp( &Size );
	}

	/* oCit@CN[Y */
	fclose(BinFD);

	/* R[hTCYn */
	*cnt = (unsigned short)Size;
	return rc;
}
/**********************************************************************/
/*   ReadBin : Read BIN file                                          */
/*                                                                    */
/*       : BinarytH[}bg̃t@COutTbl.bcodeɓǂݏo   */
/*       : obt@ʒm|C^                                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadBin( unsigned int * Size )
{
unsigned int BuffSize=0;	/* o̓obt@TCY */

	*Size = 0;
	/* t@CTCY擾 */
	if (fseek( BinFD , 0 , SEEK_END )){
		return ILLBIN;
	}
	BuffSize = (unsigned int)ftell( BinFD );
	if (fseek( BinFD , 0 , SEEK_SET )){
		return ILLBIN;
	}
	/* obt@TCY`FbN */
	if ( BuffSize > ( MAXOBJ - AsmAdr )){
		/* ǂݏoTCYI[o[ */
		return ADOFLOW;
	}
	/* 1 passڂȂI */
	if ( !pass ){
		*Size = BuffSize;
		return NORM;
	}
	/* o̓obt@mۂ */
	if ( !(OutTbl.bcode = malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated.\n");
		return ILLBIN;
	}
	/* BINt@Cǂ݂ */
	if ( fread( OutTbl.bcode , (size_t)BuffSize , (size_t)1 , BinFD ) != 1 ){
		printf("File read error.\n");
		return ILLBIN;
	}

	/* obt@Zbg */
	*Size = BuffSize;
	return NORM;
}
/**********************************************************************/
/*   ReadBmp : Read Bitmap file                                       */
/*                                                                    */
/*       : BMPtH[}bg̃t@COutTbl.bcodeɓǂݏo      */
/*       : obt@ʒm|C^                                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadBmp( unsigned int * Size )
{
unsigned char ImgTbl[62];
unsigned int bfsize;	/* t@CTCY */
unsigned int boffset;	/* 摜f[^܂ł̃ItZbg */
unsigned int bisize;	/* wb_̑傫 */
unsigned int width;	/* 摜̕ */
unsigned int width2;	/* 摜̕(ۂ̃f[^ʒu) */
unsigned int height;	/* 摜̍ */
unsigned int imgsize;	/* 摜̃TCY */
unsigned short bitcount;/* F */
unsigned short parret1,parret2;/* pbgf[^ */
unsigned int x,y;
unsigned char * ImageTbl=0;/* ǂݏopobt@|C^ */
unsigned int BuffSize=0;	/* o̓obt@TCY */
unsigned int ImgSize=0;	/* 摜obt@TCY */

	*Size = 0;
	/* C[We[u */
	memset( ImgTbl , 0 , sizeof(ImgTbl) );
	/* BMPt@Cwb_ǂݏo(62oCgŒ) */
	if ( fread( ImgTbl , 1 , 62 , BinFD ) != 62 )
		goto bmp_read_error;
	/* BMPwb_ */
	if ( (ImgTbl[0] != 'B')||(ImgTbl[1] != 'M'))
		goto bmp_read_error;
	/* BMPt@CTCY擾 */
	bfsize = Getlong(2);
	/* 摜f[^܂ł̃ItZbg擾 */
	boffset = Getlong(10);
	/* wb_̑傫 */
	bisize = Getlong(14);
	/* wb_TCY`FbN */
	if ( (( bisize != 40 )&&( bisize != 12 ))||( bisize > boffset )||( bfsize <= boffset ) )
		goto bmp_read_error;
	/* BMPp[^擾 */
	switch( bisize ){
	/* Windows`tH[}bgł */
	case 40:
		width = Getlong(18);/*  */
		height = Getlong(22);/*  */
		bitcount = Getword(28);/* F */
		imgsize = Getlong(34);
		parret1 = Getparret(54);
		parret2 = ( (boffset-bisize-14) == 6 ) ? Getparret(57) : Getparret(58);
		break;
	/* OS2`tH[}bgł */
	case 12:
		width = (unsigned int)Getword(18);/*  */
		height = (unsigned int)Getword(20);/*  */
		bitcount = Getword(24);/* F */
		imgsize = 0;
		parret1 = Getparret(26);
		parret2 = ( (boffset-bisize-14) == 6 ) ? Getparret(29) : Getparret(30);
		break;
	/* m̃tH[}bg̏ꍇAG[I */
	default:
		goto bmp_read_error;
	}
	/* mN摜ł */
	if ( bitcount != 1 )
		goto bmp_read_error;
	/* obt@TCY쐬 */
	ImgSize = bfsize - boffset;

	/* 𑜓x̃f[^Mp */
	BuffSize = width * height / 8;

	/* obt@TCY`FbN */
	if ( BuffSize > ( MAXOBJ - AsmAdr )){
		/* ǂݏoTCYI[o[ */
		return ADOFLOW;
	}
	/* 1 passڂȂI */
	if ( !pass ){
		*Size = BuffSize;
		return NORM;
	}
	/* ǂݏoe[umۂ */
	if ( !(ImageTbl = malloc( (size_t)ImgSize ))){
		printf("Read Buffer Not Allocated.\n");
		return ILLBMP;
	}
	/* ǂݏoe[u */
	memset( ImageTbl , 0xff , (size_t)ImgSize );
	/* Bitmapf[^ǂݏo */
	if ( fseek( BinFD , boffset , SEEK_SET ) )
		goto bmp_read_error;
	if ( fread( ImageTbl , (size_t)1 , (size_t)ImgSize , BinFD ) != ImgSize )
		goto bmp_read_error;

	/* o̓obt@mۂ */
	if ( !( OutTbl.bcode = malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated.\n");
		/* ǂݏoobt@J */
		free( ImageTbl );
		return ILLBMP;
	}
	/* obt@ */
	memset( OutTbl.bcode, 0 , (size_t)BuffSize );
	/* width␳ */
	width2 = ( width & 0x1f ) ? (width+32)/32*32 : width;
	/* BMP --> oCiϊ */
	for ( x = 0 ; x < width ; x++ ){
		for ( y = 0 ; y < height ; y++ ){
			/* 𔻒肷 */
			if (parret1 < parret2){
				/* if point(x,y) = 0 */
				if ( !(ImageTbl[(height-y-1)*(width2/8)+(x/8)]&((unsigned char)(0x80>>(x&7)))) )
					/* then pset(x,y) */
					OutTbl.bcode[x+((y/8)*width)] |= (unsigned char)(0x80>>(y&7));
			}
			else{
				/* if point(x,y) = 1 */
				if ( (ImageTbl[(height-y-1)*(width2/8)+(x/8)]&((unsigned char)(0x80>>(x&7)))) )
					/* then pset(x,y) */
					OutTbl.bcode[x+((y/8)*width)] |= (unsigned char)(0x80>>(y&7));
			}
		}
	}
	/* ǂݏoobt@J */
	free( ImageTbl );
	*Size = BuffSize;
	return NORM;

bmp_read_error:
	/* ǂݏoobt@J */
	if (ImageTbl) free( ImageTbl );
	return ILLBMP;
}

/**********************************************************************/
/*   PrintList : Print List File                                      */
/*                                                                    */
/*       : OutTblɏ]APs̃Xgo͂                 */
/*       : sԍJE^                                         */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void PrintList( int count )
{
int	i,cnt,n,len;
unsigned short sts;
	/* Xgo͗vȂꍇAI */
	if ( ListFlag ) return;
	len = 0;
	cnt = 0;
	/* sԍo */
	if (pr) printf( "%05d:%04X  " , count+1 , OutTbl.adr );
	fprintf( LstFD ,"%05d:%04X  " , count+1 , OutTbl.adr );

	/* ʏ햽߁^^ߎʎo */
	sts = OutTbl.kind;
	/* ORG/#INCBIN߈ȊO͖ߌR[ho */
	if (OutTbl.byte && ( sts != OP_ORG )&&( sts != OP_INCBIN ) ){
		/* f[^ */
		for ( cnt = 0 ; cnt < 4 ; cnt++ ){
			if ( cnt < OutTbl.byte){
				/* DSߎ́A0o͂ */
				if ( sts == OP_DS ){
					if (pr) printf( "00" );
					fprintf( LstFD ,"00" );
				}
				 else{
					if (pr) printf( "%02X" , OutTbl.code[cnt] );
					fprintf( LstFD ,"%02X" , OutTbl.code[cnt] );
				}
			}
			else{
				if (pr) printf( "  " );
				if (!Tab) fprintf( LstFD ,"  " );
			}
		}
		if (pr) printf( "  " );
		if (!Tab) fprintf( LstFD ,"  " );
		else fprintf( LstFD ,"%s", ( ( OutTbl.byte & 0x3 ) == 1) ? "\t\t" : "\t" );
	}
	else{
		/* f[^Ȃ */
		if ( sts != OP_INCBIN ) cnt = OutTbl.byte;
		if (pr) printf( "          " );
		if ( !Tab ) fprintf( LstFD ,"          " );
		else fprintf( LstFD ,"\t\t" );
	}
	/* xR[ho */
	if ( OutTbl.label ){
		sprintf( oprwk , "%s:" , OutTbl.label );
		if (pr) printf("%-13s" , oprwk );
		if (!Tab) fprintf( LstFD ,"%-13s" , oprwk );
		else{
			fprintf( LstFD ,"%s" , oprwk );
			if ( strlen(oprwk) < 8 )
				fprintf( LstFD ,"\t" );
		}
	}
	else{
		if ( OutTbl.opr[0] ){
			/* 󔒏o */
			if (pr) printf( "             " );
			if ( !Tab )	fprintf( LstFD ,"             " );
			else fprintf( LstFD ,"\t" );
		}
	}
	/* jjbNo */
	if ( OutTbl.opr[0] ){
		if (pr) printf( "%-08s" , OutTbl.opr[0] );
		if (!Tab) fprintf( LstFD ,"%-08s" , OutTbl.opr[0] );
		else{
			fprintf( LstFD ,"%s" , OutTbl.opr[0] );
			if ( strlen(OutTbl.opr[0]) < 8 )
				fprintf( LstFD ,"\t" );
		}
		len += 8;
	}
	/* Iyho */
	i = 1;
	while( OutTbl.opr[i] ){
		if (pr) printf( "%s" , OutTbl.opr[i] );
		fprintf( LstFD ,"%s" , OutTbl.opr[i] );
		len += strlen(OutTbl.opr[i]);
		i++;
	}
	/* Rgo */
	if ( OutTbl.comment ){
		if (pr) printf( "%s" , OutTbl.comment );
		/* 󔒏o */
		if ( len ){
			if (!Tab){
				n = ( len > 30 ) ? 0 : ( 30 - len );
				for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ," " );
			}
			else{
				n = ( len > 31 ) ? 0 : ( 4 - (len/8) );
				for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ,"\t" );
			}
		}
		fprintf( LstFD ,"%s" , OutTbl.comment );
	}
	/* s */
	if (pr) printf( "\n" );
	fprintf( LstFD ,"\n" );
	/* ߌR[ho */
	while( OutTbl.byte && ( cnt < OutTbl.byte ) ){
		if (pr) printf("            ");
		fprintf(LstFD , "            ");
		/* f[^ */
		for ( i = 0 ; i < 4 ; i++ , cnt++ ){
			if ( cnt < OutTbl.byte){
				/* DSߎ́A0o͂ */
				if ( sts == OP_DS ){
					if (pr) printf( "00" );
					fprintf( LstFD ,"00" );
				}
				 else{
				 	if ( sts != OP_INCBIN ){
						if (pr) printf( "%02X" , OutTbl.code[cnt] );
						fprintf( LstFD ,"%02X" , OutTbl.code[cnt] );
					}
					else{
						if (pr) printf( "%02X" , OutTbl.bcode[cnt] );
						fprintf( LstFD ,"%02X" , OutTbl.bcode[cnt] );
					}
				}
			}
			else{
				if (pr) printf( "  " );
				if (!Tab) fprintf( LstFD ,"  " );
			}
		}
		/* TABo */
		if ( Tab ) {
			fprintf( LstFD ,"\t");
			if ( ( OutTbl.byte & 0x3 ) == 1 ) fprintf( LstFD ,"\t");
		}
		/* #incbinjjbNo */
		if ( sts == OP_INCBIN ){
			/* DBߏo */
			if (pr) printf( "               DB      " );
			if ( !Tab ) fprintf( LstFD ,"               DB      " );
			else fprintf( LstFD ,"\tDB\t" );
			for ( n = cnt-i ; n < cnt ; n++){
				if ( n < OutTbl.byte){
					if (pr) printf( "&H%02X" , OutTbl.bcode[n] );
					fprintf( LstFD ,"&H%02X" , OutTbl.bcode[n] );
					/* J}o */
					if ( ( n < cnt-1 )&&( n < OutTbl.byte-1) ){
						if (pr) printf( "," );
						fprintf( LstFD ,"," );
					}
				}
			}
		}
		/* s */
		if (pr) printf( "\n" );
		fprintf( LstFD ,"\n" );
	}
	/* EJECTv */
	if ( LineFeed ){
		/* Line Feed(0xc)o */
		fprintf( LstFD ,"%c", 0xc );
		/* wb_o */
		fprintf( LstFD , "%s%s - ",name,rev );
		fprintf( LstFD ,"ASSEMBLY LIST OF [%s]\n", SrcFile );
		LineFeed = 0;
	}
}

/**********************************************************************/
/*   ErrPut : Error Print                                             */
/*                                                                    */
/*       : G[bZ[Wo͂                             */
/*       : sԍJE^AG[ԍ                             */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void ErrPut( int cnt , int err )
{
int	i;
	/* G[s̏o */
	pr = 1;
	ListFlag = 0;
	PrintList( cnt );

	/* ̓R[hɊYG[bZ[Wo */
	for ( i = 0 ; i < MAXERR-1 ; i++ ){
		if ( errtbl[i].code==err )	break;
	}
	printf("LINE:%d ERROR CODE:%03d %s\n" , cnt+1, err , errtbl[i].msg );
	fprintf( LstFD ,"LINE:%d ERROR CODE:%03d %s\n" , cnt+1, err , errtbl[i].msg );
}
